#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "dragon2kernel4xi.py">
#<abstract4xi abstract = "DRAGON kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "dragon2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'DRAGON2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4dragon',                      # ACK               

            'execute2kernel4dragon',                  # ACK 5.8    p169                                             
            'execute2task4dragon',                    # ACK 5.8    p172   
            'execute2nativekernel4dragon',            # ACK 5.8    p174     
            
            'create2kernel4dragon',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4dragon',         # ACK 5.7.1  p158  
                       
            'delete2kernel4dragon',                   # ACK

            'fetch2kernel4dragon',                    # ACK 
            
            'get2kernelinfo4dragon',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4dragon',         # ACK 5.7.3  p164  
            'get2kernelarginfo4dragon',               # ACK 5.7.3  p166                                  
            
            'release2kernel4dragon',                  # ACK 5.7.1  p159                                         
            'retain2kernel4dragon',                   # ACK 5.7.1  p159   
 
            'set2kernel4dragon',                      # ACK 
            'set2kernelcallback4dragon',              # ACK 
            'set2kernelarg4dragon',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4dragon'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from dragon2buffer4xi import get2bufferinfo4dragon

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from dragon2commandqueue4xi import DRAGON2CommandQueue4Xi
from dragon2commandqueue4xi import create2commandqueue4dragon 
from dragon2commandqueue4xi import flush2commandqueue4dragon
from dragon2commandqueue4xi import finish2commandqueue4dragon
from dragon2commandqueue4xi import get2commandqueueinfo4dragon
from dragon2commandqueue4xi import release2commandqueue4dragon
from dragon2commandqueue4xi import retain2commandqueue4dragon
from dragon2commandqueue4xi import set2commandqueue4dragon
from dragon2commandqueue4xi import trace2commandqueue4dragon

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from dragon2context4xi import DRAGON2Context4Xi 
from dragon2context4xi import create2context4dragon
from dragon2context4xi import get2context4dragon
from dragon2context4xi import release2context4dragon
from dragon2context4xi import retain2context4dragon
from dragon2context4xi import set2context4dragon


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from dragon2device4xi import DRAGON4Xi
from dragon2device4xi import init2dragon4xi 
from dragon2device4xi import set2dragon4xi
from dragon2device4xi import get2dragon4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from dragon2event4xi import DRAGON2Event4Xi
from dragon2event4xi import create2event4dragon
from dragon2event4xi import get2eventinfo4dragon
from dragon2event4xi import release2event4dragon
from dragon2event4xi import retain2event4dragon
from dragon2event4xi import set2eventcallback4dragon 
from dragon2event4xi import set2event4dragon
from dragon2event4xi import trace2event4dragon
from dragon2event4xi import wait2event4dragon


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from dragon2program4xi import DRAGON2Program4Xi
from dragon2program4xi import add2programwithsource4dragon
from dragon2program4xi import add2programwithbinary4dragon
from dragon2program4xi import build2program4dragon
from dragon2program4xi import compile2program4dragon
from dragon2program4xi import create2programwithsource4dragon
from dragon2program4xi import create2programwithbinary4dragon
from dragon2program4xi import delete2programwithsource4dragon
from dragon2program4xi import delete2programwithbinary4dragon
from dragon2program4xi import get2programinfo4dragon
# from dragon2program4xi import get2programbuildinfo4dragon
from dragon2program4xi import link2program4dragon
from dragon2program4xi import release2program4dragon
from dragon2program4xi import retain2program4dragon
from dragon2program4xi import set2programcallback4dragon 
from dragon2program4xi import set2programwithsource4dragon
from dragon2program4xi import set2programwithbinary4dragon
from dragon2program4xi import trace2program4dragon
# from dragon2program4xi import unload2compiler4dragon

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global dragon2kernel4xi                                                    # Kernel of DRAGON
global dragon2build4xi                                                     # Build of DRAGON
global dragon2compile4xi                                                   # Compile of DRAGON
global dragon2trace4xi                                                     # TRACE

global fetch2code4dragon                                                   # Fetched code

global import2use4dragon                                                   # Imports of target function for Process4Xi

global kb2fetch4dragon                                                     # Knowledgebase for fetching
global kb2kernel4dragon                                                    # Knowledgebase for kernel   

global folder2lib4dragon                                                   # Folder of DRAGON library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4dragon

global target2function4dragon                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2dragon = 'dragon'
key2dir = temp2dragon[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4dragon = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4dragon = profile2fetch.keys()

kb2fetch4dragon = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4dragon[1] = folder2lib4dragon + 'dragon2sampler4xi5test.py'                                                         # Python code
kb2fetch4dragon[2] = folder2lib4dragon + '__pycache__//dragon2sampler4xi.cpython-33.pyc'   
kb2fetch4dragon[3] = folder2lib4dragon + 'dragon2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4dragon[4] = folder2lib4dragon + "bin//dragon2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4dragon[1]  = folder2lib4dragon + 'dragon2sampler4xi5test.py'                                                      
# kb2fetch4dragon[2]  = folder2lib4dragon + '__pycache__//dragon2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4dragon[3]  = folder2lib4dragon + 'dragon2image4xi5test.py'
# kb2fetch4dragon[4]  = folder2lib4dragon + '__pycache__//dragon2image4xi.cpython-33.pyc'
# kb2fetch4dragon[5]  = folder2lib4dragon + 'dragon3image4xi5test.py'
# kb2fetch4dragon[6]  = folder2lib4dragon + '__pycache__//dragon3image4xi.cpython-33.pyc'
# kb2fetch4dragon[7]  = folder2lib4dragon + 'dragon2commandqueue4xi5test.py'
# kb2fetch4dragon[8]  = folder2lib4dragon + '__pycache__//dragon2commandqueue4xi.cpython-33.pyc'
# kb2fetch4dragon[9]  = folder2lib4dragon + 'dragon2event4xi5test.py'
# kb2fetch4dragon[10] = folder2lib4dragon + '__pycache__//dragon2event4xi.cpython-33.pyc'
# kb2fetch4dragon[10]  = folder2lib4dragon + 'DRAGON2kernel4xi5test.py'
# kb2fetch4dragon[11] = folder2lib4dragon + '__pycache__//dragon2program.cpython-33.pyc'

fetch2code4dragon = {}                                                                                                 # reception arena in memory for code

kb2kernel4dragon = {}
kb2kernel4dragon ['.py'] = {}
kb2kernel4dragon ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4dragon ['.py'] ['VALUE']          = "dragon2sampler4xi5test" 
kb2kernel4dragon ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4dragon ['.cpp'] = {}
kb2kernel4dragon ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4dragon ['.cpp'] ['VALUE']          = "dragon2dummy4xi5test" 
kb2kernel4dragon ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of DRAGON imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import create2commandqueue4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importflush2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import flush2commandqueue4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import finish2commandqueue4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4dragon" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import get2commandqueueinfo4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import release2commandqueue4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importretain2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import retain2commandqueue4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importset2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importset2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import set2commandqueue4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4dragon" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4dragon():
   global target2function4dragon
   from dragon2commandqueue4xi import trace2commandqueue4dragon as target2function4dragon
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4dragon" usage = " importing target function for Process4Xi">
def importcreate2context4dragon():
   global target2function4dragon
   from dragon2context4xi import create2context4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2context4dragon" usage = " importing target function for Process4Xi">
def importget2context4dragon():
   global target2function4dragon
   from dragon2context4xi import get2context4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importrelease2context4dragon" usage = " importing target function for Process4Xi">
def importrelease2context4dragon():
   global target2function4dragon
   from dragon2context4xi import release2context4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importretain2context4dragon" usage = " importing target function for Process4Xi">
def importretain2context4dragon():
   global target2function4dragon
   from dragon2context4xi import retain2context4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importset2context4dragon" usage = " importing target function for Process4Xi">
def importset2context4dragon():
   global target2function4dragon
   from dragon2context4xi import set2context4dragon as target2function4dragon
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of DRAGON imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2dragon4xi" usage = " importing target function for Process4Xi">
def importinit2dragon4xi():
   global target2function4dragon
   from dragon2device4xi import init2dragon4xi as target2function4dragon 
#</function4xi>
 
#<function4xi function = "importset2dragon4xi" usage = " importing target function for Process4Xi">
def importset2dragon4xi():
   global target2function4dragon
   from dragon2device4xi import set2dragon4xi   as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2dragon4xi" usage = " importing target function for Process4Xi">
def importget2dragon4xi():
   global target2function4dragon
   from dragon2device4xi import get2dragon4xi   as target2function4dragon
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4dragon" usage = " importing target function for Process4Xi">
def importcreate2event4dragon():
   global target2function4dragon
   from dragon2event4xi import create2event4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2eventinfo4dragon" usage = " importing target function for Process4Xi">
def importget2eventinfo4dragon():
   global target2function4dragon
   from dragon2event4xi import get2eventinfo4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importrelease2event4dragon" usage = " importing target function for Process4Xi">
def importrelease2event4dragon():
   global target2function4dragon
   from dragon2event4xi import release2event4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importretain2event4dragon" usage = " importing target function for Process4Xi">
def importretain2event4dragon():
   global target2function4dragon
   from dragon2event4xi import retain2event4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importset2eventcallback4dragon" usage = " importing target function for Process4Xi">
def importset2eventcallback4dragon():
   global target2function4dragon
   from dragon2event4xi import set2eventcallback4dragon as target2function4dragon 
#</function4xi>
 
#<function4xi function = "importset2event4dragon" usage = " importing target function for Process4Xi">
def importset2event4dragon():
   global target2function4dragon
   from dragon2event4xi import set2event4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importtrace2event4dragon" usage = " importing target function for Process4Xi">
def importtrace2event4dragon():
   global target2function4dragon
   from dragon2event4xi import trace2event4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importwait2event4dragon" usage = " importing target function for Process4Xi">
def importwait2event4dragon():
   global target2function4dragon
   from dragon2event4xi import wait2event4dragon as target2function4dragon
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4dragon" usage = " importing target function for Process4Xi">
def importcreate2image4dragon():
   global target2function4dragon
   from dragon2image4xi import create2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2imageinfo4dragon" usage = " importing target function for Process4Xi">
def importget2imageinfo4dragon():
   global target2function4dragon
   from dragon2image4xi import get2imageinfo4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4dragon" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4dragon():
   global target2function4dragon
   from dragon2image4xi import get2supportedimageformats4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4dragon():
   global target2function4dragon
   from dragon2image4xi import manoeuvre2copyimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4dragon():
   global target2function4dragon
   from dragon2image4xi import manoeuvre2copyimagetobuffer4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4dragon():
   global target2function4dragon
   from dragon2image4xi import manoeuvre2copybuffertoimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4dragon():
   global target2function4dragon
   from dragon2image4xi import manoeuvre2readimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4dragon():
   global target2function4dragon
   from dragon2image4xi import manoeuvre2writeimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4dragon():
   global target2function4dragon
   from dragon2image4xi import manoeuvre2mapimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importcopy2image4dragon" usage = " importing target function for Process4Xi">
def importcopy2image4dragon():
   global target2function4dragon
   from dragon2image4xi import copy2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4dragon" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4dragon():
   global target2function4dragon
   from dragon2image4xi import copy2imagetobuffer4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4dragon" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4dragon():
   global target2function4dragon
   from dragon2image4xi import copy2buffertoimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importread2image4dragon" usage = " importing target function for Process4Xi">
def importread2image4dragon():
   global target2function4dragon
   from dragon2image4xi import read2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmap2image4dragon" usage = " importing target function for Process4Xi">
def importmap2image4dragon():
   global target2function4dragon
   from dragon2image4xi import map2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importrelease2image4dragon" usage = " importing target function for Process4Xi">
def importrelease2image4dragon():
   global target2function4dragon
   from dragon2image4xi import release2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importretain2image4dragon" usage = " importing target function for Process4Xi">
def importretain2image4dragon():
   global target2function4dragon
   from dragon2image4xi import retain2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importset2imagecallback4dragon" usage = " importing target function for Process4Xi">
def importset2imagecallback4dragon():
   global target2function4dragon
   from dragon2image4xi import set2imagecallback4dragon as target2function4dragon 
#</function4xi>
 
#<function4xi function = "importset2image4dragon" usage = " importing target function for Process4Xi">
def importset2image4dragon():
   global target2function4dragon
   from dragon2image4xi import set2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importtrace2image4dragon" usage = " importing target function for Process4Xi">
def importtrace2image4dragon():
   global target2function4dragon
   from dragon2image4xi import trace2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importwait2image4dragon" usage = " importing target function for Process4Xi">
def importwait2image4dragon():
   global target2function4dragon
   from dragon2image4xi import wait2image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importwrite2image4dragon" usage = " importing target function for Process4Xi">
def importwrite2image4dragon():
   global target2function4dragon
   from dragon2image4xi import write2image4dragon as target2function4dragon
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4dragon" usage = " importing target function for Process4Xi">
def importcreate3image4dragon():
   global target2function4dragon
   from dragon3image4xi import create3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget3imageinfo4dragon" usage = " importing target function for Process4Xi">
def importget3imageinfo4dragon():
   global target2function4dragon
   from dragon3image4xi import get3imageinfo4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4dragon" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4dragon():
   global target2function4dragon
   from dragon3image4xi import get3supportedimageformats4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4dragon():
   global target2function4dragon
   from dragon3image4xi import manoeuvre3copyimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4dragon():
   global target2function4dragon
   from dragon3image4xi import manoeuvre3copyimagetobuffer4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4dragon():
   global target2function4dragon
   from dragon3image4xi import manoeuvre3copybuffertoimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4dragon():
   global target2function4dragon
   from dragon3image4xi import manoeuvre3readimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4dragon():
   global target2function4dragon
   from dragon3image4xi import manoeuvre3writeimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4dragon" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4dragon():
   global target2function4dragon
   from dragon3image4xi import manoeuvre3mapimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importcopy3image4dragon" usage = " importing target function for Process4Xi">
def importcopy3image4dragon():
   global target2function4dragon
   from dragon3image4xi import copy3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4dragon" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4dragon():
   global target2function4dragon
   from dragon3image4xi import copy3imagetobuffer4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4dragon" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4dragon():
   global target2function4dragon
   from dragon3image4xi import copy3buffertoimage4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importread3image4dragon" usage = " importing target function for Process4Xi">
def importread3image4dragon():
   global target2function4dragon
   from dragon3image4xi import read3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importmap3image4dragon" usage = " importing target function for Process4Xi">
def importmap3image4dragon():
   global target2function4dragon
   from dragon3image4xi import map3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importrelease3image4dragon" usage = " importing target function for Process4Xi">
def importrelease3image4dragon():
   global target2function4dragon
   from dragon3image4xi import release3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importretain3image4dragon" usage = " importing target function for Process4Xi">
def importretain3image4dragon():
   global target2function4dragon
   from dragon3image4xi import retain3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importset3imagecallback4dragon" usage = " importing target function for Process4Xi">
def importset3imagecallback4dragon():
   global target2function4dragon
   from dragon3image4xi import set3imagecallback4dragon as target2function4dragon 
#</function4xi>
 
#<function4xi function = "importset3image4dragon" usage = " importing target function for Process4Xi">
def importset3image4dragon():
   global target2function4dragon
   from dragon3image4xi import set3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importtrace3image4dragon" usage = " importing target function for Process4Xi">
def importtrace3image4dragon():
   global target2function4dragon
   from dragon3image4xi import trace3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importwait3image4dragon" usage = " importing target function for Process4Xi">
def importwait3image4dragon():
   global target2function4dragon
   from dragon3image4xi import wait3image4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importwrite3image4dragon" usage = " importing target function for Process4Xi">
def importwrite3image4dragon():
   global target2function4dragon
   from dragon3image4xi import write3image4dragon as target2function4dragon
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4dragon" usage = " importing target function for Process4Xi">
def importcreate2sampler4dragon():
   global target2function4dragon
   from dragon2sampler4xi import create2sampler4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4dragon" usage = " importing target function for Process4Xi">
def importget2samplerinfo4dragon():
   global target2function4dragon
   from dragon2sampler4xi import get2samplerinfo4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importrelease2sampler4dragon" usage = " importing target function for Process4Xi">
def importrelease2sampler4dragon():
   global target2function4dragon
   from dragon2sampler4xi import release2sampler4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importretain2sampler4dragon" usage = " importing target function for Process4Xi">
def importretain2sampler4dragon():
   global target2function4dragon
   from dragon2sampler4xi import retain2sampler4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importset2samplercallback4dragon" usage = " importing target function for Process4Xi">
def importset2samplercallback4dragon():
   global target2function4dragon
   from dragon2sampler4xi import set2samplercallback4dragon as target2function4dragon 
#</function4xi>
 
#<function4xi function = "importset2sampler4dragon" usage = " importing target function for Process4Xi">
def importset2sampler4dragon():
   global target2function4dragon
   from dragon2sampler4xi import set2sampler4dragon as target2function4dragon
#</function4xi>
 
#<function4xi function = "importtrace2sampler4dragon" usage = " importing target function for Process4Xi">
def importtrace2sampler4dragon():
   global target2function4dragon
   from dragon2sampler4xi import trace2sampler4dragon as target2function4dragon
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4dragon" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4dragon():
   global target2function4dragon
   from dragon2kernel4xi import create2programwithsource4dragon as target2function4dragon
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4dragon" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4dragon():
   global target2function4dragon
   from dragon2kernel4xi import create2programwithbinary4dragon as target2function4dragon
#</function4xi> 

#<function4xi function = "importadd2programwithsource4dragon" usage = " importing target function for Process4Xi">
def importadd2programwithsource4dragon():
   global target2function4dragon
   from dragon2kernel4xi import add2programwithsource4dragon as target2function4dragon
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4dragon" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4dragon():
   global target2function4dragon
   from dragon2kernel4xi import add2programwithbinary4dragon as target2function4dragon
#</function4xi>

#<function4xi function = "importbuild2program4dragon" usage = " importing target function for Process4Xi">
def importbuild2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import build2program4dragon as target2function4dragon
#</function4xi>

#<function4xi function = "importbuild2program4dragon" usage = " importing target function for Process4Xi">
def importbuild2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import build2program4dragon as target2function4dragon
#</function4xi>

#<function4xi function = "importcompile2program4dragonX" usage = " importing target function for Process4Xi">
def importcompile2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import compile2program4dragon as target2function4dragon
#</function4xi>

#<function4xi function = "importdelete2programwithsource4dragonX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4dragon():
   global target2function4dragon
   from dragon2kernel4xi import delete2programwithsource4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4dragonX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4dragon():
   global target2function4dragon
   from dragon2kernel4xi import delete2programwithbinary4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importget2programinfo4dragonX" usage = " importing target function for Process4Xi">
def importget2programinfo4dragon():
   global target2function4dragon
   from dragon2kernel4xi import get2programinfo4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importlink2program4dragonX" usage = " importing target function for Process4Xi">
def importlink2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import link2program4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importrelease2program4dragonX" usage = " importing target function for Process4Xi">
def importrelease2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import release2program4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importretain2program4dragonX" usage = " importing target function for Process4Xi">
def importretain2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import retain2program4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importset2programcallback4dragonX" usage = " importing target function for Process4Xi">
def importset2programcallback4dragon():
   global target2function4dragon
   from dragon2kernel4xi import set2programcallback4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importset2programwithsource4dragonX" usage = " importing target function for Process4Xi">
def importset2programwithsource4dragon():
   global target2function4dragon
   from dragon2kernel4xi import set2programwithsource4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importset2programwithbinary4dragonX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4dragon():
   global target2function4dragon
   from dragon2kernel4xi import set2programwithbinary4dragon as target2function4dragon
#</function4xi>    

#<function4xi function = "importtrace2program4dragonX" usage = " importing target function for Process4Xi">
def importtrace2program4dragon():
   global target2function4dragon
   from dragon2kernel4xi import trace2program4dragon as target2function4dragon
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of DRAGON imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importdragon2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importdragon2commandqueue4xi5test():
   global target2function4dragon
   from dragon2commandqueue4xi5test import dragon2commandqueue4xi5test as target2function4dragon
#</function4xi> 

#<function4xi function = "importdragon2event4xi5test" usage = " importing target function for Process4Xi">
def importdragon2event4xi5test():
   global target2function4dragon
   from dragon2event4xi5test import dragon2event4xi5test as target2function4dragon
#</function4xi>
 
#<function4xi function = "importdragon2image4xi5test" usage = " importing target function for Process4Xi">
def importdragon2image4xi5test():
   global target2function4dragon
   from dragon2image4xi5test import dragon2image4xi5test as target2function4dragon
#</function4xi>
 
#<function4xi function = "importdragon3image4xi5test" usage = " importing target function for Process4Xi">
def importdragon3image4xi5test():
   global target2function4dragon
   from dragon3image4xi5test import dragon3image4xi5test as target2function4dragon
#</function4xi>
 
#<function4xi function = "importdragon2sampler4xi5test" usage = " importing target function for Process4Xi">
def importdragon2sampler4xi5test():
   global target2function4dragon
   from dragon2sampler4xi5test import dragon2sampler4xi5test as target2function4dragon
#</function4xi>
 
#<function4xi function = "importDRAGON2kernel4xi5test" usage = " importing target function for Process4Xi">
def importdragon2kernel4xi5test():
   global target2function4dragon
   from dragon2kernel4xi5test import dragon2kernel4xi5test as target2function4dragon
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of DRAGON imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4dragon" usage = " Error handling for importing target function for Process4Xi">
def handle2error4dragon():
   global import2use4dragon
   print ("HANDLE2ERROR4DRAGON OF DRAGON2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4dragon = import2use4dragon.keys()
   for key2import4dragon in keys2import4dragon:
       print(key2import4dragon,import2use4dragon[key2import4dragon]) 
#</function4xi> 


import2use4dragon = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of DRAGON imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4dragon["create2commandqueue4dragon"] = importcreate2commandqueue4dragon        
import2use4dragon["flush2commandqueue4dragon"] = importflush2commandqueue4dragon 
import2use4dragon["finish2commandqueue4dragon"] = importfinish2commandqueue4dragon 
import2use4dragon["get2commandqueueinfo4dragon"] = importget2commandqueueinfo4dragon 
import2use4dragon["release2commandqueue4dragon"] = importrelease2commandqueue4dragon 
import2use4dragon["retain2commandqueue4dragon"] = importretain2commandqueue4dragon 
import2use4dragon["set2commandqueue4dragon"] = importset2commandqueue4dragon 
import2use4dragon["trace2commandqueue4dragon"] = importtrace2commandqueue4dragon 

# -------------------------------------------------------------------------------------------------
# Context module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dragon["create2context4dragon"] = importcreate2context4dragon 
import2use4dragon["get2context4dragon"] = importget2context4dragon 
import2use4dragon["release2context4dragon"] = importrelease2context4dragon 
import2use4dragon["retain2context4dragon"] = importretain2context4dragon 
import2use4dragon["set2context4dragon"] = importset2context4dragon 

# -------------------------------------------------------------------------------------------------
# Device module of DRAGON imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4dragon["init2dragon4xi"] = importinit2dragon4xi 
import2use4dragon["set2dragon4xi"] = importset2dragon4xi 
import2use4dragon["get2dragon4xi"] = importget2dragon4xi 

# -------------------------------------------------------------------------------------------------
# Event module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dragon["create2event4dragon"] = importcreate2event4dragon 
import2use4dragon["get2eventinfo4dragon"] = importget2eventinfo4dragon 
import2use4dragon["release2event4dragon"] = importrelease2event4dragon 
import2use4dragon["retain2event4dragon"] = importretain2event4dragon 
import2use4dragon["set2eventcallback4dragon"] = importset2eventcallback4dragon 
import2use4dragon["set2event4dragon"] = importset2event4dragon 
import2use4dragon["trace2event4dragon"] = importtrace2event4dragon 
import2use4dragon["wait2event4dragon"] = importwait2event4dragon 

# -------------------------------------------------------------------------------------------------
# 2D Image module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dragon["create2image4dragon"] = importcreate2image4dragon 
import2use4dragon["get2imageinfo4dragon"] = importget2imageinfo4dragon 
import2use4dragon["get2supportedimageformats4dragon"] = importget2supportedimageformats4dragon 
import2use4dragon["manoeuvre2copyimage4dragon"] = importmanoeuvre2copyimage4dragon 
import2use4dragon["manoeuvre2copyimagetobuffer4dragon"] = importmanoeuvre2copyimagetobuffer4dragon 
import2use4dragon["manoeuvre2copybuffertoimage4dragon"] = importmanoeuvre2copybuffertoimage4dragon 
import2use4dragon["manoeuvre2readimage4dragon"] = importmanoeuvre2readimage4dragon 
import2use4dragon["manoeuvre2writeimage4dragon"] = importmanoeuvre2writeimage4dragon 
import2use4dragon["manoeuvre2mapimage4dragon"] = importmanoeuvre2mapimage4dragon 
import2use4dragon["copy2image4dragon"] = importcopy2image4dragon 
import2use4dragon["copy2imagetobuffer4dragon"] = importcopy2imagetobuffer4dragon 
import2use4dragon["copy2buffertoimage4dragon"] = importcopy2buffertoimage4dragon 
import2use4dragon["read2image4dragon"] = importread2image4dragon 
import2use4dragon["map2image4dragon"] = importmap2image4dragon 
import2use4dragon["release2image4dragon"] = importrelease2image4dragon 
import2use4dragon["retain2image4dragon"] = importretain2image4dragon 
import2use4dragon["set2imagecallback4dragon"] = importset2imagecallback4dragon 
import2use4dragon["set2image4dragon"] = importset2image4dragon 
import2use4dragon["trace2image4dragon"] = importtrace2image4dragon 
import2use4dragon["wait2image4dragon"] = importwait2image4dragon 
import2use4dragon["write2image4dragon"] = importwrite2image4dragon 

# -------------------------------------------------------------------------------------------------
# 3D Image module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dragon["create3image4dragon"] = importcreate3image4dragon 
import2use4dragon["get3imageinfo4dragon"] = importget3imageinfo4dragon 
import2use4dragon["get3supportedimageformats4dragon"] = importget3supportedimageformats4dragon 
import2use4dragon["manoeuvre3copyimage4dragon"] = importmanoeuvre3copyimage4dragon 
import2use4dragon["manoeuvre3copyimagetobuffer4dragon"] = importmanoeuvre3copyimagetobuffer4dragon 
import2use4dragon["manoeuvre3copybuffertoimage4dragon"] = importmanoeuvre3copybuffertoimage4dragon 
import2use4dragon["manoeuvre3readimage4dragon"] = importmanoeuvre3readimage4dragon 
import2use4dragon["manoeuvre3writeimage4dragon"] = importmanoeuvre3writeimage4dragon 
import2use4dragon["manoeuvre3mapimage4dragon"] = importmanoeuvre3mapimage4dragon 
import2use4dragon["copy3image4dragon"] = importcopy3image4dragon 
import2use4dragon["copy3imagetobuffer4dragon"] = importcopy3imagetobuffer4dragon 
import2use4dragon["copy3buffertoimage4dragon"] = importcopy3buffertoimage4dragon 
import2use4dragon["read3image4dragon"] = importread3image4dragon 
import2use4dragon["map3image4dragon"] = importmap3image4dragon 
import2use4dragon["release3image4dragon"] = importrelease3image4dragon 
import2use4dragon["retain3image4dragon"] = importretain3image4dragon 
import2use4dragon["set3imagecallback4dragon"] = importset3imagecallback4dragon 
import2use4dragon["set3image4dragon"] = importset3image4dragon 
import2use4dragon["trace3image4dragon"] = importtrace3image4dragon 
import2use4dragon["wait3image4dragon"] = importwait3image4dragon 
import2use4dragon["write3image4dragon"] = importwrite3image4dragon 

# -------------------------------------------------------------------------------------------------
# Sampler module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dragon["create2sampler4dragon"] = importcreate2sampler4dragon 
import2use4dragon["get2samplerinfo4dragon"] = importget2samplerinfo4dragon 
import2use4dragon["release2sampler4dragon"] = importrelease2sampler4dragon 
import2use4dragon["retain2sampler4dragon"] = importretain2sampler4dragon 
import2use4dragon["set2samplercallback4dragon"] = importset2samplercallback4dragon 
import2use4dragon["set2sampler4dragon"] = importset2sampler4dragon 
import2use4dragon["trace2sampler4dragon"] = importtrace2sampler4dragon 

# -------------------------------------------------------------------------------------------------
# Program module of DRAGON imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dragon["trace2program4dragon"] = importtrace2program4dragon
import2use4dragon["set2programwithbinary4dragon"] = importset2programwithbinary4dragon
import2use4dragon["set2programwithsource4dragon"] = importset2programwithsource4dragon
import2use4dragon["set2programcallback4dragon"] = importset2programcallback4dragon
import2use4dragon["retain2program4dragon"] = importretain2program4dragon
import2use4dragon["release2program4dragon"] = importrelease2program4dragon
import2use4dragon["link2program4dragon"] = importlink2program4dragon
import2use4dragon["get2programinfo4dragon"] = importget2programinfo4dragon
import2use4dragon["delete2programwithbinary4dragon"] = importdelete2programwithbinary4dragon
import2use4dragon["delete2programwithsource4dragon"] = importdelete2programwithsource4dragon
import2use4dragon["compile2program4dragon"] = importcompile2program4dragon
import2use4dragon["build2program4dragon"] = importbuild2program4dragon
import2use4dragon["build2program4dragon"] = importbuild2program4dragon
import2use4dragon["add2programwithbinary4dragon"] = importadd2programwithbinary4dragon
import2use4dragon["add2programwithsource4dragon"] = importadd2programwithsource4dragon
import2use4dragon["create2programwithbinary4dragon"] = importcreate2programwithbinary4dragon
import2use4dragon["create2programwithsource4dragon"] = importcreate2programwithsource4dragon



# -------------------------------------------------------------------------------------------------
# Test modules of DRAGON imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4dragon["dragon2commandqueue4xi5test"] = importdragon2commandqueue4xi5test 
import2use4dragon["dragon2event4xi5test"] = importdragon2event4xi5test 
import2use4dragon["dragon2image4xi5test"] = importdragon2image4xi5test 
import2use4dragon["dragon3image4xi5test"] = importdragon3image4xi5test 
import2use4dragon["dragon2sampler4xi5test"] = importdragon2sampler4xi5test 
import2use4dragon["dragon2kernel4xi5test"] = importdragon2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4dragon" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF DRAGON2KERNEL4XI5TEST - TRYING TO TRACE DRAGON: ', time4xi())      
#   print('=' *33)      
#   trace2dragon = None
#   try:
#       trace2dragon = trace2kernel4dragon() 
#       print('(Step 15B/25) OF DRAGON2KERNEL4XI5TEST - TRACE2DRAGON: ', trace2dragon)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4dragon-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4dragon', 'METHOD': 'trace2kernel4dragon'} 
#   except:
#       print('(Step 15Z1/25) OF DRAGON2KERNEL4XI5TEST *** FAILED TO TRACE DRAGON: ', trace2dragon) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4dragon(task4trace2dragon=None):  

    '''
    creates callback to dragon2kernel4xi
    '''
    
    global dragon2trace4xi
    global folder2lib4dragon    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4dragon" 
    method2print = "trace2kernel4dragon"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4dragon-started: " + str(trace2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2dragon-to-trace2kernel4dragon: " + str(task4trace2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    dragon2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2dragon is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY DRAGONIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2dragon = {}                                                                                            
            
        task4trace2dragon['CLASS']   = "trace2kernel4dragon"                                                              # DRAGONIZE ZPU TRACE!
        task4trace2dragon['METHOD']  = "trace2kernel4dragon" 
        task4trace2dragon['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4dragon-failed " + str(dragon2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2dragon-set-by-trace2kernel4dragon to: " + str(task4trace2dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY DRAGONIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2dragon-try-by-trace2kernel4dragon: " + str(task4trace2dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        dragon2trace4xi ['CLASS']  = task4trace2dragon['CLASS']                                                           # DRAGONIZE DRAGON TRACE!
        dragon2trace4xi ['METHOD']  = task4trace2dragon['METHOD']
        dragon2trace4xi ['MESSAGE'] = task4trace2dragon['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; dragon2trace4xi-set-by-trace2kernel4dragon to: " + str(dragon2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; dragon-trace-failed-by-trace2kernel4dragon: " + str(task4trace2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE DRAGON TRACE
        # =================================
        class2print   = task4trace2dragon['CLASS']                                                                     # DRAGONIZE DRAGON TRACE!
        method2print  = task4trace2dragon['METHOD']
        
        message2print = task4trace2dragon['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # DRAGONIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4dragon"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4dragon"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-dragon-trace-failed-by-trace2kernel4dragon: " + str(task4trace2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4dragon"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4dragon"                
        message2print = "{(Step 3D/33) performed" + "; dragon-trace-performed-by-trace2kernel4dragon: " + str(task4trace2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; dragon-trace-failed-by-trace2kernel4dragon: " + str(task4trace2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; dragon2trace4xi-returning-by-trace2kernel4dragon: " + str(dragon2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return dragon2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4dragon" usage = "
#
#   response4execute2kernel = execute2kernel4dragon()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4dragon(task4execute2dragon=None):  

    '''
    executes kernel to DRAGON 
    '''
    global folder2lib4dragon  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4dragon" 
    method2print = "execute2kernel4dragon"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4dragon-started: " + str(execute2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2dragon-to-execute2kernel4dragon: " + str(task4execute2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2dragon = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2dragon is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2dragon = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2dragon-set-by-execute2kernel4dragon to: " + str(task4execute2dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2dragon = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2dragon-set-by-execute2kernel4dragon to: " + str(status4execute2dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2dragon-returning-by-execute2kernel4dragon: " + str(status4execute2dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2dragon
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4dragon" usage = "
#
#   print('(Step 14A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF DRAGON ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4dragon()                                                                                                 
#       print('(Step 14B/700) OF DRAGON2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF DRAGON TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF DRAGON ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4dragon(task4set2kernelcallback=None):

    '''
    registers callback function to dragon2kernel4xi
    '''
    global dragon2kernel4xi
    global folder2lib4dragon  
        
    class2print = "set2kernelcallback4dragon" 
    method2print = "set2kernelcallback4dragon"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4dragon-started: " + str(set2kernelcallback4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4dragon-started
    
    try:
    
        dragon2kernel4xi ['CALLBACK'] = trace2kernel4dragon
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-dragon2kernel4xi-returning-by-set2kernelcallback4dragon: " + str(dragon2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return dragon2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4dragon: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4dragon-returning-by-set2kernelcallback4dragon: " + str(trace2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4dragon
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4dragon" usage = "
#
#   try:                               
#       response4execute2task = execute2task4dragon(task4execute2task)
#       print('(Step 99B/700) OF DRAGON2KERNEL4XI5TEST - BUILT PROGRAM OF DRAGON DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF DRAGON DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4dragon(task4execute2dragon=None):

    '''
    executes  program to DRAGON 
    '''
    global dragon2execute4xi
    global folder2lib4dragon  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4dragon"
    method2print = "execute2task4dragon" 

    message2print = "{(Step 1A/33) started" + "; execute2task4dragon-started: " + str(execute2task4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4dragon-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2dragon-to-execute2task4dragon: " + str(task4execute2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4dragon: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2dragon is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO DRAGON! 
            # -----------------------------------------------------------------------------------------    
            task4execute2dragon = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2dragon-initialized-by-execute2task4dragon: " + str(task4execute2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2dragon = {}
            message2print = "{(Step 1A/70) trying" + "; program2dragon-trying-by-create2kernel4dragon: " + str(program2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2dragon = create2kernel4dragon()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2dragon-got-by-create2kernel4dragon: " + str(program2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2dragon-failed-by-create2kernel4dragon: " + str(program2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2dragon ['PROGRAM'] = program2dragon
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4dragon = trace2kernel4dragon                                                               # CALLBACK FUNCTION FOR DRAGON
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4dragon-created-by-execute2task4dragon: " + str(function2callback4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4dragon"                                                            # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4dragon"                                                            # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4dragon-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4dragon: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2dragon['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2dragon['FUNCTION2CALLBACK'] = function2callback4dragon                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2dragon['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2dragon-created-by-execute2task4dragon: " + str(task4execute2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2dragon-yielded-by-execute2task4dragon: " + str(task4execute2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2dragon.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4dragon: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR DRAGON ! 
    # ---------------------------------------------------------------------------------------------    
    dragon2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; dragon2execute4xi-initialized-by-execute2task4dragon to: " + str(dragon2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4dragon: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dragon2execute4xi['PROGRAM'] = task4execute2dragon['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4dragon: " + str(dragon2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-dragon2execute4xi-yielded-by-execute2task4dragon: " + str(dragon2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4dragon: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dragon2execute4xi['OPTIONS'] = task4execute2dragon['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4dragon: " + str(dragon2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-dragon2execute4xi-yielded-by-execute2task4dragon: " + str(dragon2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4dragon: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dragon2execute4xi['CALLBACK'] = task4execute2dragon['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4dragon: " + str(dragon2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-dragon2execute4xi-yielded-by-execute2task4dragon: " + str(dragon2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4dragon: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dragon2execute4xi['USERDATA'] = task4execute2dragon['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4dragon: " + str(dragon2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-dragon2execute4xi-yielded-by-execute2task4dragon: " + str(dragon2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2execute4xi ['ACK2RETURN']  = code2ack
    dragon2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; dragon2execute4xi-returning-by-execute2task4dragon: " + str(dragon2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return dragon2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4dragon" usage = "
#     
#   print('(Step 2A1/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR DRAGON ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4dragon()
#   except:
#       print('(Step 2Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR DRAGON *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4dragon(task4kernel2dragon=None):

    '''
    creates kernel for DRAGON
    '''
    global dragon2kernel4xi                                                                                            # Kernel of DRAGON    
    global folder2lib4dragon  
    global kb2kernel4dragon                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4dragon" 
    method2print = "create2kernel4dragon"

    message2print = "{(Step 1A/70) started" + "; create2kernel4dragon-started: " + str(create2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4dragon at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2dragon-to-create2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    dragon2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2dragon is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO DRAGON! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2dragon = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2dragon-created-by-create2kernel4dragon: " + str(task4kernel2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4dragon = trace2kernel4dragon                                                                # CALLBACK FUNCTION FOR DRAGON
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4dragon-created-by-create2kernel4dragon: " + str(function2callback4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4dragon at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4dragon"                                                          # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4dragon"                                                          # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4dragon-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4dragon: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dragon-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dragon',
            #  'METHOD': 'create2kernel4dragon'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2dragon['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2dragon['FUNCTION2CALLBACK'] = function2callback4dragon                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2dragon-created-by-create2kernel4dragon: " + str(task4kernel2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4dragon at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dragon-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dragon',
            #  'METHOD': 'create2kernel4dragon'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4dragon: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4dragon: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4dragon: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2dragon['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2dragon = {}
            message2print = "{(Step 3A/70) trying" + "; context2dragon-trying-by-create2kernel4dragon: " + str(context2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2dragon = get2context4dragon()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2dragon-got-by-create2kernel4dragon: " + str(context2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2dragon-failed-by-create2kernel4dragon: " + str(context2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2dragon ['CONTEXT'] = context2dragon           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2dragon = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2dragon-trying-by-create2kernel4dragon: " + str(device2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2dragon = get2dragon4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2dragon-got-by-create2kernel4dragon: " + str(device2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2dragon-failed-by-create2kernel4dragon: " + str(device2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2dragon ['DEVICE'] = device2dragon
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2dragon ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2dragon = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2dragon-trying-by-create2kernel4dragon: " + str(queue2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2dragon = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2dragon-got-by-create2kernel4dragon: " + str(queue2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2dragon-failed-by-create2kernel4dragon: " + str(queue2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2dragon ['QUEUE'] = queue2dragon

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2dragon = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2dragon-trying-by-create2kernel4dragon: " + str(pipe2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2dragon = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2dragon-got-by-create2kernel4dragon: " + str(pipe2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2dragon-failed-by-create2kernel4dragon: " + str(pipe2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2dragon ['PIPE'] = pipe2dragon 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2dragon = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2dragon-trying-by-create2kernel4dragon: " + str(commandqueueinfo2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2dragon = get2commandqueueinfo4dragon()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2dragon-got-by-create2kernel4dragon: " + str(commandqueueinfo2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2dragon-failed-by-create2kernel4dragon: " + str(commandqueueinfo2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2dragon ['COMMANDQUEUE'] = commandqueueinfo2dragon
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2dragon = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2dragon-trying-by-create2kernel4dragon: " + str(bufferinfo2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2dragon = get2bufferinfo4dragon()                                                               # SYSTEM CREATES BUFFER FOR DRAGON, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2dragon-got-by-create2kernel4dragon: " + str(bufferinfo2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2dragon-failed-by-create2kernel4dragon: " + str(bufferinfo2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2dragon ['BUFFER'] = bufferinfo2dragon 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2dragon = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2dragon-trying-by-create2kernel4dragon: " + str(eventinfo2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2dragon = get2eventinfo4dragon()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2dragon-got-by-create2kernel4dragon: " + str(eventinfo2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2dragon-failed-by-create2kernel4dragon: " + str(eventinfo2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2dragon ['EVENT'] = eventinfo2dragon             

            
            task4kernel2dragon ['CODE4PY']       = {}                                                                  
            task4kernel2dragon ['CODE4CPP']      = {}                                                                  
            task4kernel2dragon ['CODE4C']        = {} 
            task4kernel2dragon ['CODE4CL']       = {} 
                       
            task4kernel2dragon ['CODE4PYC']      = {}                                                                  
            task4kernel2dragon ['CODE4BIN']      = {}
 
            task4kernel2dragon ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2dragon ['DIRECTORY4CPP'] = {}
            task4kernel2dragon ['DIRECTORY4C']   = {}
            task4kernel2dragon ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2dragon ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2dragon ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4dragon = folder2lib4dragon                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4dragon-set-by-create2kernel4dragon to: " + str(dir2py4dragon)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2dragon ['DIRECTORY4PY'] = dir2py4dragon
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4dragon: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4dragon):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4dragon: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4dragon: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4dragon + dragon2sampler4xi5test.py; dragon2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4dragon-calling-by-create2kernel4dragon: " + str(fetch2kernel4dragon)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4dragon at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4dragon-by-create2kernel4dragon: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4dragon + dragon2sampler4xi5test.py; dragon2dummy4xi5test.cpp 
                    
                    fetch2kernel4dragon(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4DRAGON DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4dragon-performed-by-create2kernel4dragon: " + str(fetch2kernel4dragon) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4dragon at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4dragon-got-by-create2kernel4dragon: " + str(fetch2code4dragon) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4dragon = fetch2code4dragon.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4dragon-using-by-create2kernel4dragon: " + str(keys2explore4dragon) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4dragon + dragon2sampler4xi5test.py; dragon2dummy4xi5test.cpp
            
            for key2explore4dragon in keys2explore4dragon:
                name2program4dragon=os.path.splitext(key2explore4dragon)                                                  # dragon2sampler4xi5test + py
                key2extension4dragon = name2program4dragon[1]                                                              
                if key2extension4dragon == '.py':                          
                    task4kernel2dragon ['CODE4PY'] [key2explore4dragon] = fetch2code4dragon[key2explore4dragon]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4dragon  = {}
            keys2py4dragon = fetch2code4dragon.keys()                                                                     # dragon2sampler4xi5test.py
            for key2py4dragon in keys2py4dragon:
                name2program4dragon=os.path.splitext(key2py4dragon)                                                       # dragon2sampler4xi5test + py
                key2extension4dragon = name2program4dragon[1]                                                             # py   
                if key2extension4dragon == '.py':                          
                    size2py4dragon[key2py4dragon] = len(fetch2code4dragon[key2py4dragon])                                       # length of saved py code 

            task4kernel2dragon ['SIZE4PY'] = size2py4dragon
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4dragon-set-by-create2kernel4dragon to: " + str(size2py4dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4dragon + dragon2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4dragon = folder2lib4dragon                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4dragon-set-by-create2kernel4dragon to: " + str(dir2c4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4dragon 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2dragon ['DIRECTORY4CPP']  = dir2c4dragon
            task4kernel2dragon ['DIRECTORY4C']    = dir2c4dragon
            task4kernel2dragon ['DIRECTORY4CLPP'] = dir2c4dragon
            task4kernel2dragon ['CODE4CPP'] = {} 
            task4kernel2dragon ['CODE4C']   = {} 
            task4kernel2dragon ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4dragon = fetch2code4dragon.keys()
            for key2c4dragon in keys2c4dragon:
                name2c4dragon=os.path.splitext(key2c4dragon)                                                  
                key2extension4dragon = name2c4dragon[1]                                                             # C++, C, CL 
                if key2extension4dragon == '.cpp':                          
                    task4kernel2dragon ['CODE4CPP'] [key2c4dragon] = fetch2code4dragon[key2c4dragon]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4dragon-set-by-create2kernel4dragon to: " + str(key2c4dragon)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dragon + dragon2dummy4xi5test.cpp
                if key2extension4dragon == '.c':                          
                    task4kernel2dragon ['CODE4C'] [key2c4dragon] = fetch2code4dragon[key2c4dragon]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4dragon-set-by-create2kernel4dragon to: " + str(key2c4dragon)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dragon +
                if key2extension4dragon == '.cl':                          
                    task4kernel2dragon ['CODE4CL'] [key2c4dragon] = fetch2code4dragon[key2c4dragon]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4dragon-set-by-create2kernel4dragon to: " + str(key2c4dragon)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dragon + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4dragon  = {}
            keys2c4dragon = fetch2code4dragon.keys()                                                                # 
            for key2c4dragon in keys2c4dragon:
                name2program4dragon=os.path.splitext(key2c4dragon)                                                  # 
                key2extension4dragon = name2program4dragon[1]                                                       #    
                if key2extension4dragon == '.cpp':                          
                    size2c4dragon[key2c4dragon] = len(fetch2code4dragon[key2c4dragon])                                    # length of saved C++ code
                    task4kernel2dragon ['SIZE4CPP'] = size2c4dragon 
                if key2extension4dragon == '.c':                          
                    size2c4dragon[key2c4dragon] = len(fetch2code4dragon[key2c4dragon])                                    # length of saved C code
                    task4kernel2dragon ['SIZE4C'] = size2c4dragon
                if key2extension4dragon == '.cl':                          
                    size2c4dragon[key2c4dragon] = len(fetch2code4dragon[key2c4dragon])                                    # length of saved CL code
                    task4kernel2dragon ['SIZE4CL'] = size2c4dragon 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4dragon-set-by-create2kernel4dragon to: " + str(size2c4dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon + dragon2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4dragon = folder2lib4dragon + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4dragon-set-by-create2kernel4dragon to: " + str(dir2pycache4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2dragon ['DIRECTORY4PYC'] = dir2pycache4dragon
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4dragon: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4dragon):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4dragon: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4dragon: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4dragon + __pycache__//dragon2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4dragon-calling-by-create2kernel4dragon: " + str(fetch2kernel4dragon)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4dragon at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4dragon-by-create2kernel4dragon: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4dragon + __pycache__//dragon2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4dragon(file2walk)                                                                     # fetches kernel files into fetch2code4dragon dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4dragon-performed-by-create2kernel4dragon: " + str(fetch2kernel4dragon) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4dragon at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4dragon-got-by-create2kernel4dragon: " + str(fetch2code4dragon) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2dragon ['CODE4PYC'] = {}
            keys2pyc4dragon = fetch2code4dragon.keys()
            for key2pyc4dragon in keys2pyc4dragon:
                name2program4dragon=os.path.splitext(key2pyc4dragon)                                                      # dragon2sampler4xi5test.cpython-33.pyc
                key2extension4dragon = name2program4dragon[1]                                                             # pyc 
   
                if key2extension4dragon == '.pyc':                          
                    task4kernel2dragon ['CODE4PYC'] [key2pyc4dragon] = fetch2code4dragon[key2pyc4dragon]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4dragon-set-by-create2kernel4dragon to: " + str(key2pyc4dragon)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4dragon  = {}

            for key2pyc4dragon in keys2pyc4dragon:
                name2program4dragon=os.path.splitext(key2pyc4dragon)                                                      # dragon2sampler4xi5test.cpython-32 + pyc
                key2extension4dragon = name2program4dragon[1]                                                             # pyc 
                if key2extension4dragon == '.pyc':                          
                    size2pyc4dragon[key2pyc4dragon] = len(fetch2code4dragon[key2pyc4dragon])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4dragon-set-by-create2kernel4dragon to: " + str(key2pyc4dragon)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2dragon ['SIZE4PYC'] = size2pyc4dragon
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4dragon-set-by-create2kernel4dragon to: " + str(size2pyc4dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4dragon = folder2lib4dragon + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4dragon-set-by-create2kernel4dragon to: " + str(dir2bin4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2dragon ['DIRECTORY4BIN'] = dir2bin4dragon
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4dragon: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4dragon):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4dragon: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4dragon: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4dragon + bin//dragon2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4dragon-calling-by-create2kernel4dragon: " + str(fetch2kernel4dragon)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4dragon at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4dragon-by-create2kernel4dragon: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dragon + bin//dragon2dummy4xi5test.exe
                    
                    fetch2kernel4dragon(file2walk)                                                                     # fetches kernel files into fetch2code4dragon dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4dragon-performed-by-create2kernel4dragon: " + str(fetch2kernel4dragon) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4dragon at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4dragon-got-by-create2kernel4dragon: " + str(fetch2code4dragon) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2dragon ['CODE4BIN'] = {}
            
            keys2bin4dragon = fetch2code4dragon.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4dragon-using-by-create2kernel4dragon: " + str(keys2bin4dragon) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4dragon + 'dragon2dummy4xi5test.cpp', 'dragon2sampler4xi5test.py']
            
            for key2bin4dragon in keys2bin4dragon:
                name2program4dragon=os.path.splitext(key2bin4dragon)                                                      # dragon2dummy4xi5test.exe
                key2extension4dragon = name2program4dragon[1]                                                             # bin 
   
                if key2extension4dragon == '.exe':                          
                    task4kernel2dragon ['CODE4BIN'] [key2bin4dragon] = fetch2code4dragon[key2bin4dragon]                        # binary code(s)   
                                        
            size2bin4dragon  = {}
            keys2bin4dragon = fetch2code4dragon.keys()                                                                    # dragon2dummy4xi5test.exe
            for key2bin4dragon in keys2bin4dragon:
                name2program4dragon=os.path.splitext(key2bin4dragon)                                                      # dragon2sampler4xi5test.cpython-32 + bin
                key2extension4dragon = name2program4dragon[1]                                                             # bin 
                if key2extension4dragon == '.exe':                          
                    size2bin4dragon[key2bin4dragon] = len(fetch2code4dragon[key2bin4dragon])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2dragon ['SIZE4BIN'] = size2bin4dragon
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4dragon-set-by-create2kernel4dragon to: " + str(size2bin4dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dragon ['COUNT4PY']     = 0
            task4kernel2dragon ['COUNT4CPP']    = 0
            task4kernel2dragon ['COUNT4C']      = 0
            task4kernel2dragon ['COUNT4CL']     = 0
            task4kernel2dragon ['COUNT4PYC']    = 0
            task4kernel2dragon ['COUNT4BIN']    = 0

            keys2code4dragon = fetch2code4dragon.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4dragon-using-by-create2kernel4dragon: " + str(keys2code4dragon) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4dragon + 'dragon2dummy4xi5test.cpp', folder2lib4dragon + 'dragon2sampler4xi5test.py']

            
            for key2code4dragon in keys2code4dragon:
                name2program4dragon=os.path.splitext(key2code4dragon)                                                    
                key2extension4dragon = name2program4dragon[1]                                                             
                if key2extension4dragon == '.py':                          
                    task4kernel2dragon ['COUNT4PY']     = task4kernel2dragon ['COUNT4PY']  + 1 
                if key2extension4dragon == '.cpp':                          
                    task4kernel2dragon ['COUNT4CPP']    = task4kernel2dragon ['COUNT4CPP'] + 1                                            
                if key2extension4dragon == '.c':                          
                    task4kernel2dragon ['COUNT4C']      = task4kernel2dragon ['COUNT4C']   + 1              
                if key2extension4dragon == '.cl':                          
                    task4kernel2dragon ['COUNT4CL']     = task4kernel2dragon ['COUNT4CL']  + 1                                  
                if key2extension4dragon == '.pyc':                          
                    task4kernel2dragon ['COUNT4PYC']    = task4kernel2dragon ['COUNT4PYC'] + 1                            
                if key2extension4dragon == '.exe':                          
                    task4kernel2dragon ['COUNT4BIN']    = task4kernel2dragon ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dragon ['LANGUAGE'] = {}
            
            for key2code4dragon in keys2code4dragon:
                name2program4dragon=os.path.splitext(key2code4dragon)                                                     
                key2extension4dragon = name2program4dragon[1]                                                             
                if key2extension4dragon == '.py':                          
                    task4kernel2dragon ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4dragon == '.cpp':                          
                    task4kernel2dragon ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4dragon == '.c':                          
                    task4kernel2dragon ['LANGUAGE'] ['C']   = "C"  
                if key2extension4dragon == '.cl':                          
                    task4kernel2dragon ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2dragon  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2dragon-set-by-create2kernel4dragon to: " + str(count2reference2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2dragon ['COUNT2REFERENCE'] = count2reference2dragon                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dragon ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2dragon ['PROGRAM'] = create2programwithsource4dragon()
                keys2program = task4kernel2dragon ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4dragon to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2dragon-failed-by-create2kernel4dragon: " + str(task4kernel2dragon ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dragon ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2dragon ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4dragon  = kb2kernel4dragon ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4dragon-using-by-create2kernel4dragon: " + str(tag2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4dragon    = kb2kernel4dragon ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4dragon-using-by-create2kernel4dragon: " + str(value2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # dragon2sampler4xi5test
            
            attribute2search4dragon= kb2kernel4dragon ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4dragon-using-by-create2kernel4dragon: " + str(attribute2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dragon in keys2code4dragon:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon]
                    keys2line4dragon = code2examine4dragon.keys()
                    for key2line4dragon in keys2line4dragon:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon] [key2line4dragon]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4dragon,tag2search4dragon)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... dragon2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4dragon,value2search4dragon)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4dragon-skipped-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "dragon2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4dragon,attribute2search4dragon)             # ...function = "dragon2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4dragon-warning-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4dragon-accepted-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "dragon2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4dragon = line2examine4dragon[index2function:index2usage-2]
                                    
                                    task4kernel2dragon ['FUNCTION'] ['.py'] [key2pythonfunction4dragon] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4dragon-used-by-create2kernel4dragon: " + str(key2pythonfunction4dragon)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # dragon2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2dragon-failed-by-create2kernel4dragon: " + str(task4kernel2dragon ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dragon ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4dragon      = kb2kernel4dragon ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4dragon-using-by-create2kernel4dragon: " + str(tag2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4dragon= kb2kernel4dragon ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4dragon-using-by-create2kernel4dragon: " + str(attribute2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dragon in keys2code4dragon:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon]
                    message2print = "{(Step 19A5/70) using" + "; key2code4dragon-using-by-create2kernel4dragon: " + str(key2code4dragon)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # dragon2dummy4xi5test.cpp
                       
                    keys2line4dragon = code2examine4dragon.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4dragon-using-by-create2kernel4dragon: " + str(keys2line4dragon)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4dragon in keys2line4dragon:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon] [key2line4dragon]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4dragon,tag2search4dragon)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4dragon-using-by-create2kernel4dragon: " + str(attribute2search4dragon)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4dragon,attribute2search4dragon)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4dragon-skipped-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4dragon-accepted-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4dragon = line2examine4dragon[27:index2usage-2]  
                                task4kernel2dragon ['FUNCTION'] ['.cpp'] [key2kernelfunction4dragon] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4dragon-used-by-create2kernel4dragon: " + str(key2kernelfunction4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2dragon-failed-by-create2kernel4dragon: " + str(task4kernel2dragon ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2DRAGON                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2dragon-yielded-by-create2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2dragon.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4dragon: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR DRAGON - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    dragon2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; dragon2kernel4xi-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4dragon = trace2kernel4dragon                                                                # CALLBACK FUNCTION FOR DRAGON
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4dragon-created-by-create2kernel4dragon: " + str(function2callback4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4dragon at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4dragon"                                                          # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4dragon"                                                          # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4dragon-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4dragon: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dragon-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dragon',
            #  'METHOD': 'create2kernel4dragon'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2dragon['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2dragon['FUNCTION2CALLBACK'] = function2callback4dragon                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2dragon-created-by-create2kernel4dragon: " + str(task4kernel2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4dragon at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dragon-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dragon',
            #  'METHOD': 'create2kernel4dragon'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['DATA2CALLBACK'] = task4kernel2dragon['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dragon-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dragon',
            #  'METHOD': 'create2kernel4dragon'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2dragon['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4dragon at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['PLATFORM'] = task4kernel2dragon['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2dragon-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['CONTEXT'] = task4kernel2dragon['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['DEVICE'] = task4kernel2dragon['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['CODE2ERROR'] = task4kernel2dragon['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2dragon = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2dragon-trying-by-create2kernel4dragon: " + str(queue2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2dragon = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2dragon-got-by-create2kernel4dragon: " + str(queue2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2dragon-failed-by-create2kernel4dragon: " + str(queue2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2dragon ['QUEUE'] = queue2dragon
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['QUEUE'] = task4kernel2dragon['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2dragon = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2dragon-trying-by-create2kernel4dragon: " + str(pipe2dragon)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2dragon = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2dragon-got-by-create2kernel4dragon: " + str(pipe2dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2dragon-failed-by-create2kernel4dragon: " + str(pipe2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2dragon ['PIPE'] = pipe2dragon 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dragon2kernel4xi['PIPE'] = task4kernel2dragon['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['COMMANDQUEUE']  = task4kernel2dragon['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['BUFFER']  = task4kernel2dragon['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['EVENT']  = task4kernel2dragon['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['COUNT4PY']  = task4kernel2dragon['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['COUNT4CPP']  = task4kernel2dragon['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['COUNT4C']  = task4kernel2dragon['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['COUNT4CL']  = task4kernel2dragon['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4dragon: " + str(task4kernel2dragon['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['COUNT4PYC']  = task4kernel2dragon['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4dragon: " + str(task4kernel2dragon['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['COUNT4BIN']  = task4kernel2dragon['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4dragon = folder2lib4dragon                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4dragon-set-by-create2kernel4dragon to: " + str(dir2py4dragon)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2dragon ['DIRECTORY4PY'] = dir2py4dragon
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['DIRECTORY4PY']  = task4kernel2dragon['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dragon
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4dragon = folder2lib4dragon                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4dragon-set-by-create2kernel4dragon to: " + str(dir2cpp4dragon)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2dragon ['DIRECTORY4CPP'] = dir2cpp4dragon
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['DIRECTORY4CPP']  = task4kernel2dragon['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dragon
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4dragon = folder2lib4dragon                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4dragon-set-by-create2kernel4dragon to: " + str(dir2c4dragon)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2dragon ['DIRECTORY4C'] = dir2c4dragon
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['DIRECTORY4C']  = task4kernel2dragon['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dragon
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4dragon = folder2lib4dragon                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4dragon-set-by-create2kernel4dragon to: " + str(dir2cl4dragon)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2dragon ['DIRECTORY4CL'] = dir2cl4dragon
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['DIRECTORY4CL']  = task4kernel2dragon['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dragon
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4dragon = folder2lib4dragon + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4dragon-set-by-create2kernel4dragon to: " + str(dir2pycache4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2dragon ['DIRECTORY4PYC'] = dir2pycache4dragon
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['DIRECTORY4PYC']  = task4kernel2dragon['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dragon + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4dragon = folder2lib4dragon + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4dragon-set-by-create2kernel4dragon to: " + str(dir2bin4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dragon + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2dragon ['DIRECTORY4BIN'] = dir2bin4dragon
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['DIRECTORY4BIN']  = task4kernel2dragon['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dragon + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4dragontask-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dragon + 'dragon2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        dragon2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['CODE4PY'] = task4kernel2dragon ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 'dragon2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4dragon2nack  = code2py4dragon2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4dragontask-try-by-create2kernel4dragon: " + str(len(task4kernel2dragon ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dragon +  dragon2dummy4xi5test.cpp
        
        dragon2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['CODE4CPP'] = task4kernel2dragon ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4dragon-created-by-create2kernel4dragon: " + str(len(dragon2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + dragon2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4dragon2nack  = code2cpp4dragon2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4dragontask-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dragon + 
        
        dragon2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['CODE4C'] = task4kernel2dragon ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4dragon2nack  = code2c4dragon2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4dragontask-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dragon + 
        
        dragon2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['CODE4CL'] = task4kernel2dragon ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4dragon2nack  = code2cl4dragon2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dragon + 
        
        dragon2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['CODE4PYC'] = task4kernel2dragon ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4dragon2nack  = code2pyc4dragon2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4dragon2bin4dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dragon + 
        
        dragon2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['CODE4BIN'] = task4kernel2dragon ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4dragon-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4dragon2nack  = code2bin4dragon2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['SIZE4PY']  = task4kernel2dragon['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4dragon-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 'dragon2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['SIZE4CPP']  = task4kernel2dragon['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4dragon-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + dragon2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['SIZE4C']  = task4kernel2dragon['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4dragon-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4dragon-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['SIZE4CL']  = task4kernel2dragon['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4dragon-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4dragon-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['SIZE4PYC']  = task4kernel2dragon['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dragon2kernel4xi['SIZE4BIN']  = task4kernel2dragon['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dragon + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dragon ['LANGUAGE'] = {}
            
            for key2code4dragon in keys2code4dragon:
                name2program4dragon=os.path.splitext(key2code4dragon)                                                     
                key2extension4dragon = name2program4dragon[1]                                                             
                if key2extension4dragon == '.py':                          
                    task4kernel2dragon ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4dragon == '.cpp':                          
                    task4kernel2dragon ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4dragon == '.c':                          
                    task4kernel2dragon ['LANGUAGE'] ['C']   = "C"  
                if key2extension4dragon == '.cl':                          
                    task4kernel2dragon ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['LANGUAGE']  = task4kernel2dragon['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2dragon  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2dragon-set-by-create2kernel4dragon to: " + str(count2reference2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2dragon ['COUNT2REFERENCE'] = count2reference2dragon     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2dragon-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4dragon: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['COUNT2REFERENCE']  = task4kernel2dragon['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4dragon: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dragon ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2dragon-try-by-create2kernel4dragon: " + str(task4kernel2dragon ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2dragon ['PROGRAM'] = create2programwithsource4dragon()
                keys2program = task4kernel2dragon ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4dragon to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2dragon-failed-by-create2kernel4dragon: " + str(task4kernel2dragon ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4dragon: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['PROGRAM']  = task4kernel2dragon['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4dragon: " + str(len(dragon2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dragon ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2dragon ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4dragon  = kb2kernel4dragon ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4dragon-using-by-create2kernel4dragon: " + str(tag2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4dragon    = kb2kernel4dragon ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4dragon-using-by-create2kernel4dragon: " + str(value2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # dragon2sampler4xi5test
            
            attribute2search4dragon= kb2kernel4dragon ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4dragon-using-by-create2kernel4dragon: " + str(attribute2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dragon in keys2code4dragon:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon]
                    keys2line4dragon = code2examine4dragon.keys()
                    for key2line4dragon in keys2line4dragon:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon] [key2line4dragon]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4dragon,tag2search4dragon)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "dragon2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4dragon,value2search4dragon)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4dragon-skipped-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "dragon2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4dragon,attribute2search4dragon)             # ....function = "dragon2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4dragon-warning-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4dragon-accepted-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "dragon2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4dragon = line2examine4dragon[index2function:index2usage-2]
                                    
                                    task4kernel2dragon ['FUNCTION'] ['.py'] [key2pythonfunction4dragon] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4dragon-used-by-create2kernel4dragon: " + str(key2pythonfunction4dragon)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # dragon2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2dragon-failed-by-create2kernel4dragon: " + str(task4kernel2dragon ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dragon ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4dragon-set-by-create2kernel4dragon to: " + str(task4kernel2dragon ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4dragon      = kb2kernel4dragon ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4dragon-using-by-create2kernel4dragon: " + str(tag2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4dragon= kb2kernel4dragon ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4dragon-using-by-create2kernel4dragon: " + str(attribute2search4dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dragon in keys2code4dragon:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon]
                    message2print = "{(Step 39A5/70) using" + "; key2code4dragon-using-by-create2kernel4dragon: " + str(key2code4dragon)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # dragon2dummy4xi5test.cpp
                       
                    keys2line4dragon = code2examine4dragon.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4dragon-using-by-create2kernel4dragon: " + str(keys2line4dragon)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4dragon in keys2line4dragon:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dragon = task4kernel2dragon ['PROGRAM'] ['CODE4SOURCE'] [key2code4dragon] [key2line4dragon]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4dragon,tag2search4dragon)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4dragon-examining-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4dragon-using-by-create2kernel4dragon: " + str(attribute2search4dragon)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4dragon,attribute2search4dragon)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4dragon-skipped-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4dragon-accepted-by-create2kernel4dragon: " + str(line2examine4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4dragon = line2examine4dragon[27:index2usage-2]  
                                task4kernel2dragon ['FUNCTION'] ['.cpp'] [key2kernelfunction4dragon] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4dragon-used-by-create2kernel4dragon: " + str(key2kernelfunction4dragon)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-dragon2kernel4xi-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4dragon: " + str(task4kernel2dragon['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'dragon2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            dragon2kernel4xi['FUNCTION']  = task4kernel2dragon['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4dragon: " + str(dragon2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'dragon2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4dragon = dragon2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4dragon-returning-by-create2kernel4dragon: " + str(keys2kernel4dragon) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4dragon = dragon2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4dragon-returning-by-create2kernel4dragon: " + str(keys2programkernel4dragon) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # dragon2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4dragon-returning-by-create2kernel4dragon: " + str(dragon2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'dragon2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return dragon2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4dragon" usage = "
#     
#   print('(Step 3A2/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dragon2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dragon2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4dragon + 'dragon2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dragon2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4dragon(task4add2kernel)
#       print('(Step 3A3/700) OF DRAGON2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4dragon(task4kernel2dragon):

    '''
    adds to kernel for DRAGON
    '''
    global dragon2kernel4xi                                                                                            # Kernel of DRAGON    
    global folder2lib4dragon  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4dragon" 
    method2print = "add2kernel4dragon"

    message2print = "{(Step 10A/70) started" + "; add2kernel4dragon-started: " + str(add2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2dragon-to-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2dragon ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4dragon: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  dragon2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4dragon: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4dragon = create2kernelsinkernel4dragon()
            keys2createwb4dragon = response2createwb4dragon.keys()
            for key2createwb4dragon in keys2createwb4dragon:
                if key2createwb4dragon == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4dragon-created-by-add2kernel4dragon: " + str(key2createwb4dragon) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  dragon2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4dragon: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; dragon2kernel4xi-failed-by-add2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4dragon: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4dragon to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4dragon +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        dragon2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2dragon ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2dragon-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4dragon to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4dragon +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2dragon-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4dragon to: " + str(dragon2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2dragon-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        dragon2kernel4xi ['COUNT4KERNEL'] = dragon2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4dragon to: " + str(dragon2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2dragon-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        dragon2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2dragon['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4dragon to: " + str(dragon2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2dragon-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2dragon-failed-by-add2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4dragon: " + str(dragon2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = dragon2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4dragon: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4dragon +  


    keys2kernel4dragon = dragon2kernel4xi.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4dragon-returning-by-add2kernel4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return dragon2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4dragon" usage = "
#     
#   print('(Step 2A2/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4dragon()
#   except:
#       print('(Step 2Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4dragon(task4program2dragon=None):

    '''
    executes native kernel of DRAGON
    '''
    global dragon2kernel4xi                                                                                            # Kernel of DRAGON    
    global import2use4dragon                                                                                           # Imports of DRAGON
    global target2function4dragon                                                                                      # Target function of Process4Xi
    global folder2lib4dragon  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4dragon" 
    method2print = "execute2nativekernel4dragon"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4dragon-started: " + str(execute2nativekernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2dragon-to-execute2nativekernel4dragon: " + str(task4program2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4dragon = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4dragon-initialized-by-execute2nativekernel4dragon to: " + str(kernel2program4dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2dragon is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2dragon-yielded-by-execute2nativekernel4dragon: " + str(task4program2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR DRAGON ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4dragon = dragon2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4dragon-using-by-execute2nativekernel4dragon: " + str(keys2kernel4dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "dragon"
        
        for key2kernel4dragon in keys2kernel4dragon:
            index2search=str.find(key2kernel4dragon,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4dragon[index2search:]                                                          # dragon2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4dragon = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4dragon-set-by-execute2nativekernel4dragon to: " + str(target2execute4dragon)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4dragon = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4DRAGON 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4dragon.get(target2execute4dragon, handle2error4dragon) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4dragon-imported-by-execute2nativekernel4dragon: " + str(target2execute4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4dragon-failed-by-execute2nativekernel4dragon: " + str(import2use4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4dragon-used-by-execute2nativekernel4dragon: " + str(target2execute4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4DRAGON
                        # ---------------------------------------------------------------------------------------------                          
                        p2dragon = Process4Xi(target=target2function4dragon, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2dragon-created-by-execute2nativekernel4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2dragon.start()
                            message2print = "{(Step 34A/70) started" + "; p2dragon-started-by-execute2nativekernel4dragon: " + str(p2dragon.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4dragon = p2dragon.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4dragon: " + str(status2process4dragon) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2dragon.run()
                                    message2print = "{(Step 36A/70) run" + "; p2dragon-run-by-execute2nativekernel4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4dragon-failed-by-execute2nativekernel4dragon: " + str(p2kernel4dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = dragon2kernel4xi['CODE4KERNEL'][key2kernel4dragon].keys()     
            kernel2program4dragon[key2kernel4dragon] = ""
            for key2line in keys2lines:
                code2add4dragon = dragon2kernel4xi ['CODE4KERNEL'] [key2kernel4dragon] [key2line]
                kernel2program4dragon[key2kernel4dragon] = kernel2program4dragon[key2kernel4dragon] + code2add4dragon.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4dragon-saved-by-execute2nativekernel4dragon to: " + str(len(kernel2program4dragon[key2kernel4dragon]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4dragon-set-by-execute2nativekernel4dragon to: " + str(len(kernel2program4dragon))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4dragon: " + str(dragon2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4dragon = kernel2program4dragon.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dragon-returning-by-execute2nativekernel4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4dragon
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4dragon" usage = "
#     
#   print('(Step 3A3/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dragon2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4dragon + 'dragon2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4dragon(task4delete2kernel) 
#       print('(Step 3A3/700) OF DRAGON2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4dragon(task4kernel2dragon):

    '''
    deletes kernel for DRAGON
    '''
    global dragon2kernel4xi                                                                                     
    global folder2lib4dragon  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4dragon" 
    method2print = "delete2kernel4dragon"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4dragon-started: " + str(delete2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4dragon at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2dragon-to-delete2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2dragon ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4dragon: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR DRAGON ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4dragon: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del dragon2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4dragon: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del dragon2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4dragon: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                dragon2kernel4xi ['COUNT4KERNEL'] = dragon2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4dragon: " + str(dragon2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4dragon: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2dragon-dragon2kernel4xi-failed-by-delete2kernel4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = dragon2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4dragon: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4dragon = dragon2kernel4xi.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4dragon-returning-by-delete2kernel4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return dragon2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4dragon" usage = "
#     
#   print('(Step 3A1/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR DRAGON ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4dragon()
#       print('(Step 3A2/700) OF DRAGON2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR DRAGON ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR DRAGON *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4dragon(task4kernel2dragon=None):

    '''
    creates kernels in program for DRAGON
    '''
    global dragon2kernel4xi                                                                                            # Kernel of DRAGON    
    global folder2lib4dragon  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4dragon" 
    method2print = "create2kernelsinprogram4dragon"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4dragon-started: " + str(create2kernelsinprogram4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2dragon-to-create2kernelsinprogram4dragon: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4dragon = dragon2kernel4xi.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dragon-returning-by-create2kernelsinprogram4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return dragon2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4dragon" usage = "
#   fetch2kernel4dragon(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4dragon(program2explore4dragon):
    global fetch2code4dragon                                                                                           # dictionary to receive files 
        
    global kb2fetch4dragon                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4dragon                                                                                         # file extensions 
    
    global folder2lib4dragon  

    class2print  = "fetch2kernel4dragon"
    method2print = "fetch2kernel4dragon" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4dragon-passed-to-fetch2kernel4dragon: " + str(program2explore4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4dragon + dragon2buffer4xi.py          ... dragon2sampler4xi5test.py ... dragon2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\dragon2buffer4xi.cpython-33.pyc   ... dragon2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\dragon2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4dragon=os.path.splitext(program2explore4dragon)                                                          # dragon2sampler4xi5test + py

    key2extension4dragon = name2program4dragon[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4dragon-set-by-fetch2kernel4dragon to: " + str(key2extension4dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4dragon: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4dragon] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4dragon-analyzing-by-fetch2kernel4dragon: " + str(program2explore4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4dragon +  dragon2buffer4xi.py ; dragon2sampler4xi5test.py ...  ... __pycache__\dragon2sampler4xi5test.cpython-33.pyc
        # dragon2dummy4xi5test.cpp
             
        path2input4dragon = program2explore4dragon
        message2print = "{(Step 1B/33) set" + "; path2input4dragon-set-by-fetch2kernel4dragon to: " + str(path2input4dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4dragon +  dragon2buffer4xi.py ; __pycache__\dragon2sampler4xi5test.cpython-33.pyc; dragon2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4dragon-analyzing-by-fetch2kernel4dragon: " + str(path2input4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4dragon +  dragon2buffer4xi.py ; dragon2dummy4xi5test.cpp 
            
        keys2fetch4dragon = kb2fetch4dragon.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4dragon-using-by-fetch2kernel4dragon: " + str(keys2fetch4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4dragon in keys2fetch4dragon:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4dragon,kb2fetch4dragon[key2fecth4dragon])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4dragon-skipped-by-fetch2kernel4dragon: " + str(path2input4dragon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4dragon +  dragon2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4dragon: " + str(path2input4dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4dragon +  dragon2sampler4xi5test.py; __pycache__//dragon2sampler4xi.cpython-33.pyc; 
                #               +  dragon2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4dragon == '.py') or (key2extension4dragon == '.cpp') or (key2extension4dragon == '.c') or (key2extension4dragon == '.cl')):
                    file2input4dragon = open(path2input4dragon,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4dragon-opened-by-fetch2kernel4dragon: " + str(file2input4dragon) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4dragon + 'dragon2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4dragon == '.pyc') or (key2extension4dragon == '.exe')):
                    file2input4dragon = open(path2input4dragon,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4dragon-opened-by-fetch2kernel4dragon: " + str(file2input4dragon) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//dragon2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4dragon = path2input4dragon
                fetch2code4dragon[key2save4dragon] = {}                                                                   # fetch2code4dragon['dragon2sampler4xi5test.py'] = {}
                number2line4dragon = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4dragon-saving-by-fetch2kernel4dragon: " + str(key2fecth4dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4dragon = file2input4dragon.readline()  
                    if not line2process4dragon:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4dragon-read-by-fetch2kernel4dragon: " + str(line2process4dragon) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of dragon2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4dragon = number2line4dragon + 1
                            fetch2code4dragon[key2save4dragon][number2line4dragon] = line2process4dragon
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4dragon-failed-by-fetch2kernel4dragon: " + str(key2fecth4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4dragon-failed-by-fetch2kernel4dragon: " + str(line2process4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4dragon-failed-by-fetch2kernel4dragon: " + str(number2line4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4dragon.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4dragon-closed-by-fetch2kernel4dragon: " + str(file2input4dragon) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4dragon + 'dragon2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4dragon + 'dragon2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # dragon2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//dragon2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # dragon2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4dragon-saved-by-fetch2kernel4dragon: " + str(fetch2code4dragon[key2save4dragon] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4dragon-saved-by-fetch2kernel4dragon: " + str(fetch2code4dragon[key2save4dragon] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # dragon2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4dragon-saved-by-fetch2kernel4dragon: " + str(fetch2code4dragon[key2save4dragon] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "dragon2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4dragon-saved-by-fetch2kernel4dragon: " + str(fetch2code4dragon[key2save4dragon] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests dragon2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4dragon-skipped-by-fetch2kernel4dragon: " + str(name2program4dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4dragon + '__pycache__//dragon2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4dragon[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4dragon: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4dragon-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4dragon-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4dragon" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4dragon)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4dragon(task4set2kernelws)
#       print('(Step 17G/700) OF DRAGON2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4dragon)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4dragon(task4kernelset2dragon=None):

    '''
    sets kernels for DRAGON
    '''
    global dragon2kernel4xi  
    global folder2lib4dragon  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4dragon"
    method2print = "set2kernel4dragon" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4dragon-started: " + str(set2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4dragon at 0x0000000003837948> 
    
    keys2task = task4kernelset2dragon.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4dragon: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if dragon2kernel4xi is None:
            dragon2kernel4xi = create2kernel4dragon()                                                                              # INITIALIZE PROGRAM FOR DRAGON 
            message2print = "{(Step 1C/70) set" + "; dragon2kernel4xi-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4dragon-skipped-by-set2kernel4dragon: " + str(create2kernel4dragon) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            dragon2kernel4xi = create2kernel4dragon()
            message2print = "{(Step 1E/70) set" + "; dragon2kernel4xi-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            dragon2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['DATA2CALLBACK'] = task4kernelset2dragon['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2dragon['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['PLATFORM'] = task4kernelset2dragon['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2dragon-try-by-set2kernel4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['CONTEXT'] = task4kernelset2dragon['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['DEVICE'] = task4kernelset2dragon['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['CODE2ERROR'] = task4kernelset2dragon['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['QUEUE'] = task4kernelset2dragon['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['PIPE'] = task4kernelset2dragon['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-dragon2kernel4xi-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['COMMANDQUEUE']  = task4kernelset2dragon['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['BUFFER']  = task4kernelset2dragon['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['EVENT']  = task4kernelset2dragon['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['COUNT4PY']  = task4kernelset2dragon['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['COUNT4PYC']  = task4kernelset2dragon['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['COUNT4C']  = task4kernelset2dragon['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['COUNT4BIN']  = task4kernelset2dragon['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4dragon: " + str(task4kernelset2dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dragon2kernel4xi['DIRECTORY4PY']  = task4kernelset2dragon['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4dragon-set-by-set2kernelwithdirectory2py4dragon4dragon to: " + str(dragon2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4dragon-yielded-by-set2kernelwithdirectory2py4dragon4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dragon2kernel4xi['DIRECTORY4PYC']  = task4kernelset2dragon['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4dragon-set-by-set2kernelwithdirectory2pyc4dragon4dragon to: " + str(dragon2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4dragon-yielded-by-set2kernelwithdirectory2pyc4dragon4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dragon2kernel4xi['DIRECTORY4CPP']  = task4kernelset2dragon['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4dragon-set-by-set2kernelwithdirectory2c4dragon4dragon to: " + str(dragon2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4dragon-yielded-by-set2kernelwithdirectory2c4dragon4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dragon2kernel4xi['DIRECTORY4BIN']  = task4kernelset2dragon['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4dragon-set-by-set2kernelwithdirectory2bin4dragon4dragon to: " + str(dragon2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4dragon-yielded-by-set2kernelwithdirectory2bin4dragon4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['CODE4PY']  = task4kernelset2dragon['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dragon + 'dragon2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "dragon2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4dragon2nack  = code2py4dragon2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['CODE4CPP']  = task4kernelset2dragon['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dragon + 
 
        code2c4dragon2ack  = code2c4dragon2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4dragon2nack  = code2c4dragon2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['CODE4PYC']  = task4kernelset2dragon['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dragon + 
 
        code2pyc4dragon2ack  = code2pyc4dragon2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4dragon2nack  = code2pyc4dragon2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['CODE4BIN']  = task4kernelset2dragon['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dragon + 
 
        code2bin4dragon2ack  = code2bin4dragon2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4dragon-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4dragon2nack  = code2bin4dragon2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['SIZE4PY']  = task4kernelset2dragon['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4dragon-yielded-by-set2kernel4dragon: " + str(task4kernelset2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['SIZE4C']  = task4kernelset2dragon['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4dragon-yielded-by-set2kernel4dragon: " + str(task4kernelset2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['SIZE4PYC']  = task4kernelset2dragon['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4dragon-yielded-by-set2kernel4dragon: " + str(task4kernelset2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4dragon-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['SIZE4BIN']  = task4kernelset2dragon['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4dragon-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4dragon-yielded-by-set2kernel4dragon: " + str(task4kernelset2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['LANGUAGE']  = task4kernelset2dragon['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['COUNT2REFERENCE']  = task4kernelset2dragon['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4dragon to: " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4dragon = dragon2kernel4xi.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dragon-returning-by-set2kernel4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return dragon2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4dragon" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4dragon)   
#   # <function set2kernelarg4dragon at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4dragon(task4set2kernelargws)
#       print('(Step 17G/700) OF DRAGON2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4dragon)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4dragon)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4dragon(task4kernelargset2dragon=None):

    '''
    sets kernel arguments for DRAGON
    '''
    global dragon2kernel4xi  
    global folder2lib4dragon  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4dragon"
    method2print = "set2kernelarg4dragon" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4dragon-started: " + str(set2kernelarg4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4dragon at 0x0000000003837948> 
    
    keys2task = task4kernelargset2dragon.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4dragon: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if dragon2kernel4xi is None:
            dragon2kernel4xi = create2kernel4dragon()                                                                              # INITIALIZE PROGRAM FOR DRAGON 
            message2print = "{(Step 1C/70) set" + "; dragon2kernel4xi-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4dragon-skipped-by-set2kernelarg4dragon: " + str(create2kernel4dragon) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            dragon2kernel4xi = create2kernel4dragon()
            message2print = "{(Step 1E/70) set" + "; dragon2kernel4xi-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            dragon2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['DATA2CALLBACK'] = task4kernelargset2dragon['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2dragon['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['PLATFORM'] = task4kernelargset2dragon['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2dragon-try-by-set2kernelarg4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['CONTEXT'] = task4kernelargset2dragon['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['DEVICE'] = task4kernelargset2dragon['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['CODE2ERROR'] = task4kernelargset2dragon['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['QUEUE'] = task4kernelargset2dragon['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['PIPE'] = task4kernelargset2dragon['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-dragon2kernel4xi-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['COMMANDQUEUE']  = task4kernelargset2dragon['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['BUFFER']  = task4kernelargset2dragon['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4dragon: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['EVENT']  = task4kernelargset2dragon['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        dragon2kernel4xi['COUNT4SOURCE']  = task4kernelargset2dragon['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4dragon: " + str(task4kernelargset2dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dragon2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2dragon['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4dragon to: " + str(dragon2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['CODE4SOURCE']  = task4kernelargset2dragon['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dragon + 'dragon2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "dragon2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['SIZE4SOURCE']  = task4kernelargset2dragon['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4dragon: " + str(task4kernelargset2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2dragon['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4dragon: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dragon2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2dragon['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4dragon to: " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4dragon = dragon2kernel4xi.keys()
    for key2kernelarg4dragon in keys2kernelarg4dragon:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4dragon-returning-by-set2kernelarg4dragon: " + str(key2kernelarg4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return dragon2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4dragon" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF DRAGON DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4dragon(task4release2kernel)
#       print('(Step 18B/700) OF DRAGON2KERNEL4XI5TEST - RELEASED KERNEL OF DRAGON DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF DRAGON DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4dragon(task4release2dragon=None):

    '''
    releases kernel for DRAGON
    '''
    global dragon2kernel4xi  
    global folder2lib4dragon  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4dragon"
    method2print = "release2kernel4dragon" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4dragon-started: " + str(release2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2dragon-to-release2kernel4dragon: " + str(task4release2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if dragon2kernel4xi is None:
            dragon2kernel4xi = create2kernel4dragon()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            dragon2kernel4xi = create2kernel4dragon()
        except:
            dragon2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; dragon2kernel4xi-yielded-by-release2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4dragon: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2dragon is None:
        task4release2dragon = {}
        task4release2dragon['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        dragon2kernel4xi['COUNT2REFERENCE'] = dragon2kernel4xi['COUNT2REFERENCE'] - task4release2dragon['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4dragon: " + str(dragon2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if dragon2kernel4xi['COUNT2REFERENCE'] < 0:
            dragon2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4dragon: " + " ** " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            dragon2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4dragon: " + " ** " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; dragon2kernel4xi-yielded-by-release2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4dragon = dragon2kernel4xi.keys()
    for key2program4dragon in keys2program4dragon:
        message2print = "{(Step 70/70) returning" + "; key2program4dragon-returning-by-release2kernel4dragon: " + str(key2program4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return dragon2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4dragon" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF DRAGON DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4dragon(task4retain2kernel)
#       print('(Step 19B/700) OF DRAGON2KERNEL4XI5TEST - RETAINED PROGRAM OF DRAGON DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF DRAGON DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4dragon(task4retain2dragon=None):

    '''
    retains kernel of DRAGON
    '''
    global dragon2kernel4xi 
    global folder2lib4dragon  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4dragon"
    method2print = "retain2kernel4dragon"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4dragon-started: " + str(retain2kernel4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2dragon-to-retain2kernel4dragon: " + str(task4retain2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2dragon is None:
        task4retain2dragon = {}
        task4retain2dragon['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2dragon-set-by-retain2kernel4dragon to: " + str(task4retain2dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2dragon.keys():
        pass
    else:
        task4retain2dragon['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4dragon to: " + str(task4retain2dragon['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2dragon['COUNT2REFERENCE'] < 1:
        task4retain2dragon['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4dragon to: " + str(task4retain2dragon['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if dragon2kernel4xi is None:
            dragon2kernel4xi = create2kernel4dragon()
            message2print = "{(Step 4A/70) created" + "; dragon2kernel4xi-created-by-retain2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            dragon2kernel4xi = create2kernel4dragon()
            message2print = "{(Step 4B/70) created" + "; dragon2kernel4xi-created-by-retain2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            dragon2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; dragon2kernel4xi-yielded-by-retain2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        dragon2kernel4xi['COUNT2REFERENCE'] = dragon2kernel4xi['COUNT2REFERENCE'] + task4retain2dragon['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4dragon: " + str(dragon2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if dragon2kernel4xi['COUNT2REFERENCE'] <= 0:
            dragon2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4dragon: " + " ** " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            dragon2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4dragon: " + " ** " + str(dragon2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; dragon2kernel4xi-yielded-by-retain2kernel4dragon: " + str(dragon2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4dragon = dragon2kernel4xi.keys()
    for key2program4dragon in keys2program4dragon:
        message2print = "{(Step 70/70) returning" + "; key2program4dragon-returning-by-retain2kernel4dragon: " + str(key2program4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return dragon2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4dragon" usage = "
#
#   print('(Step 3B1/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR DRAGON ', time4xi())     
#   try:
#       response4kernelinfo2dragon = get2kernelinfo4dragon() 
#       print('(Step 3B2/700) OF DRAGON2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR DRAGON ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR DRAGON', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4dragon(task4getinfo2kernel=None):

    '''
    gets kernel information of DRAGON
    '''
    
    global dragon2kernel4xi
    global folder2lib4dragon  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4dragon"
    method2print = "get2kernelinfo4dragon"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4dragon-started: " + str(get2kernelinfo4dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4dragon: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    dragon2kernel = {}
    try: 
        if dragon2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR DRAGON           
            # -------------------------------------------------------------------------------------           
            dragon2kernel = create2kernel4dragon()
            message2print = "{(Step 1B2/33) initialized" + "; dragon2kernel-initialized-by-get2kernelinfo4dragon to: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dragon2kernel4xi-using-by-get2kernelinfo4dragon: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF DRAGON          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            dragon2kernel = dragon2kernel4xi
            message2print = "{(Step 1C/33) using" + "; dragon2kernel-got-by-get2kernelinfo4dragon: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF DRAGON          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4dragon: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                dragon2kernel [key2task] = dragon2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-dragon2kernel-set-by-get2kernelinfo4dragon to: " + str(dragon2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4dragon: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4dragon: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dragon2kernel4xi-using-by-get2kernel4dragon: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            dragon2kernel = create2kernel4dragon()
            
            message2print = "{(Step 1F/33) initialized" + "; dragon2kernel-initialized-by-get2kernelinfo4dragon to: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                dragon2kernel = dragon2kernel4xi
                message2print = "{(Step 1G/33) set" + "; dragon2kernel-set-by-get2kernelinfo4dragon to: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4dragon: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        dragon2kernel [key2task] = dragon2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-dragon2kernel -set-by-get2kernelinfo4dragon to: " + str(dragon2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4dragon: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            dragon2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; dragon2kernel-yielded-by-get2kernel4dragon: " + str(dragon2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4dragon = dragon2kernel4xi.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dragon-returning-by-get2kernelinfo4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return dragon2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4dragon" usage = "
#
#   print('(Step 3B1/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR DRAGON ', time4xi())     
#   try:
#       response4kernelinfo2dragon = get2kernelarginfo4dragon(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF DRAGON2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR DRAGON ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR DRAGON ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4dragon(task4getinfo2kernel=None):

    '''
    gets kernel argument information of DRAGON
    '''
    
    global dragon2kernel4xi
    global folder2lib4dragon  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4dragon"
    method2print = "get2kernelarginfo4dragon"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4dragon-started: " + str(get2kernelarginfo4dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4dragon: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    dragon2kernel = {}
    try: 
        if dragon2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR DRAGON           
            # -------------------------------------------------------------------------------------           
            dragon2kernel = create2kernel4dragon()
            message2print = "{(Step 1B2/33) initialized" + "; dragon2kernel-initialized-by-get2kernelarginfo4dragon to: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dragon2kernel4xi-using-by-get2kernelarginfo4dragon: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF DRAGON          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            dragon2kernel = dragon2kernel4xi
            message2print = "{(Step 1C/33) using" + "; dragon2kernel-got-by-get2kernelarginfo4dragon: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF DRAGON          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4dragon: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                dragon2kernel [key2task] = dragon2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-dragon2kernel-set-by-get2kernelarginfo4dragon to: " + str(dragon2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4dragon: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4dragon: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dragon2kernel4xi-using-by-get2kernel4dragon: " + str(dragon2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            dragon2kernel = create2kernel4dragon()
            
            message2print = "{(Step 1F/33) initialized" + "; dragon2kernel-initialized-by-get2kernelarginfo4dragon to: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                dragon2kernel = dragon2kernel4xi
                message2print = "{(Step 1G/33) set" + "; dragon2kernel-set-by-get2kernelarginfo4dragon to: " + str(dragon2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4dragon: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        dragon2kernel [key2task] = dragon2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-dragon2kernel -set-by-get2kernelarginfo4dragon to: " + str(dragon2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4dragon: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            dragon2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; dragon2kernel-yielded-by-get2kernel4dragon: " + str(dragon2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4dragon = dragon2kernel4xi.keys()
    for key2kernel4dragon in keys2kernel4dragon:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dragon-returning-by-get2kernelarginfo4dragon: " + str(key2kernel4dragon) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return dragon2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4dragon" usage = "
#
#   response4get2buildinfo = get2buildinfo4dragon()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4dragon(task4getinfo2build=None):

    '''
    gets dragon2build4xi and dragon2build4xi
    '''
    
    global dragon2build4xi
    global folder2lib4dragon  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4dragon"
    method2print = "get2buildinfo4dragon"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4dragon-started: " + str(get2buildinfo4dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4dragon: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    dragon2build = {}
    try: 
        if dragon2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR DRAGON           
            # -------------------------------------------------------------------------------------           
            dragon2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; dragon2build-initialized-by-get2buildinfo4dragon to: " + str(dragon2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dragon2build4xi-using-by-get2buildinfo4dragon: " + str(dragon2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF DRAGON          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            dragon2build = dragon2build4xi
            message2print = "{(Step 1C/33) using" + "; dragon2build-got-by-get2buildinfo4dragon: " + str(dragon2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF DRAGON          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4dragon: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                dragon2build [key2task] = dragon2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-dragon2build-set-by-get2buildinfo4dragon to: " + str(dragon2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4dragon: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4dragon: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dragon2build4xi-using-by-get2build4dragon: " + str(dragon2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            dragon2build = {}
            message2print = "{(Step 1F/33) initialized" + "; dragon2build-initialized-by-get2buildinfo4dragon to: " + str(dragon2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                dragon2build = dragon2build4xi
                message2print = "{(Step 1G/33) set" + "; dragon2build-set-by-get2buildinfo4dragon to: " + str(dragon2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4dragon: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        dragon2build [key2task] = dragon2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-dragon2build -set-by-get2buildinfo4dragon to: " + str(dragon2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4dragon: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            dragon2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; dragon2build-yielded-by-get2build4dragon: " + str(dragon2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; dragon2build-returning-by-get2buildinfo4dragon: " + str(dragon2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return dragon2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4dragon" usage = "
#     
#   print('(Step 2AB2/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4dragon()
#       print('(Step 2BB2/700) OF DRAGON2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4dragon(task4kernelworkgroupinfo2dragon=None):

    '''
    gets kernel workgroup info of DRAGON
    '''
    global dragon2kernel4xi                                                                                            # Kernel of DRAGON    
    global import2use4dragon                                                                                           # Imports of DRAGON
    global target2function4dragon                                                                                      # Target function of Process4Xi
    global folder2lib4dragon  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4dragon" 
    method2print = "get2kernelworkgroupinfo4dragon"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4dragon-started: " + str(get2kernelworkgroupinfo4dragon)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2dragon-to-get2kernelworkgroupinfo4dragon: " + str(task4kernelworkgroupinfo2dragon) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4dragon = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2dragon is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2dragon-yielded-by-get2kernelworkgroupinfo4dragon: " + str(task4kernelworkgroupinfo2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR DRAGON ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4dragon = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4dragon-initialized-by-get2kernelworkgroupinfo4dragon to: " + str(process2kernelworkgroupinfo4dragon)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4dragon = dragon2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4dragon-using-by-get2kernelworkgroupinfo4dragon: " + str(keys2code4dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4dragon + 'dragon2sampler4xi5test.py'])
        
        unit4processing = "dragon"
        
        for key2code4dragon in keys2code4dragon:
            index2search=str.find(key2code4dragon,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4dragon[index2search:]                                                          # dragon2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4dragon = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4dragon-set-by-get2kernelworkgroupinfo4dragon to: " + str(target2link4dragon)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # dragon2sampler4xi5test

                    p2code4dragon = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4DRAGON 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4dragon.get(target2link4dragon, handle2error4dragon) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4dragon-imported-by-get2kernelworkgroupinfo4dragon: " + str(target2link4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # dragon2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4dragon-failed-by-get2kernelworkgroupinfo4dragon: " + str(import2use4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4dragon-used-by-get2kernelworkgroupinfo4dragon: " + str(target2link4dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4DRAGON
                        # ---------------------------------------------------------------------------------------------                          
                        p2dragon = Process4Xi(target=target2function4dragon, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2dragon-created-by-get2kernelworkgroupinfo4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4dragon[key2code4dragon] = p2dragon
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2dragon.start()
                            message2print = "{(Step 34A/70) started" + "; p2dragon-started-by-get2kernelworkgroupinfo4dragon: " + str(p2dragon.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4dragon = p2dragon.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4dragon: " + str(status2process4dragon) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2dragon.run()
                                    message2print = "{(Step 36A/70) run" + "; p2dragon-run-by-get2kernelworkgroupinfo4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4dragon: " + str(p2dragon) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4dragon-failed-by-get2kernelworkgroupinfo4dragon: " + str(p2code4dragon) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4dragon-set-by-get2kernelworkgroupinfo4dragon to: " + str(process2kernelworkgroupinfo4dragon)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4dragon: " + str(dragon2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dragon2kernel4xi ['ACK2RETURN']  = code2ack
    dragon2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4dragon-returning-by-get2kernelworkgroupinfo4dragon: " + str(process2kernelworkgroupinfo4dragon) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4dragon
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "DRAGON2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for DRAGON kernels" usage = "Kernel4Xi of DRAGON"
#>

# =================================================================================================
class DRAGON2Kernel4Xi(object): 
    ''' 
    DRAGON2Kernel4Xi offers  methods for DRAGON kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2dragon = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF DRAGON2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF DRAGON ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2dragon = DRAGON2Kernel4Xi()
    #       print('(Step 110B/700) OF DRAGON2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF DRAGON: ', kernelobject2dragon)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF DRAGON') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2dragon = None):
        '''
        _init__ method initializes DRAGON2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "DRAGON2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; dragon2kernel2xi-of-DRAGON2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-dragon2kernel2xi-of-DRAGON2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2dragon-sharing-by-dragon2kernel2xi-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi.classvariable2dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2dragon-passed-to-init-of-DRAGON2Kernel4Xi: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2dragon-passing-to-create2kernel4dragon-by-init-of-DRAGON2Kernel4Xi: " + str(task4kernel2dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        dragon2kernel2xi = create2kernel4dragon(task4kernel2dragon)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4dragon-performed-by-init-of-DRAGON2Kernel4Xi: " + str(create2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4dragon at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; dragon2kernel2xi-of-DRAGON2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-dragon2kernel2xi-of-DRAGON2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2dragon-shared-by-dragon2kernel2xi-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi.classvariable2dragon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-DRAGON2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-DRAGON2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO DRAGON  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dragon2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dragon2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2dragon.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF DRAGON2KERNEL4XI5TEST - ADDED KERNEL TO DRAGON  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO DRAGON WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-DRAGON2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4dragon-by-add2kernel-of-DRAGON2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4dragon(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4dragon-performed-by-add2kernel-of-DRAGON2Kernel4Xi: " + str(add2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-DRAGON2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF DRAGON WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2dragon.execute2task() 
    #       print('(Step 240B/700) OF DRAGON2KERNEL4XI5TEST - EXECUTED TASK OF DRAGON WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF DRAGON WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-DRAGON2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4dragon-by-execute2task-of-DRAGON2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        dragon2program2xi = execute2task4dragon(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4dragon-performed-by-execute2task-of-DRAGON2Kernel4Xi: " + str(execute2task4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dragon2program2xi-returning-by-execute2task-of-DRAGON2Kernel4Xi: " + str(dragon2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return dragon2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF DRAGON ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2dragon.execute2nativekernel()
    #       print('(Step 121A2/700) OF DRAGON2KERNEL4XI5TEST - EXECUTED KERNEL OF DRAGON', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF DRAGON', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-DRAGON2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4dragon-by-execute2nativekernel-of-DRAGON2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        dragon2execute2xi = execute2nativekernel4dragon(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4dragon-performed-by-execute2nativekernel-of-DRAGON2Kernel4Xi: " + str(execute2nativekernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dragon2execute2xi-returning-by-execute2nativekernel-of-DRAGON2Kernel4Xi: " + str(dragon2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return dragon2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF DRAGON WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2dragon.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF DRAGON2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF DRAGON WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF DRAGON WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-DRAGON2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4dragon-by-get2kernelworkgroupinfo-of-DRAGON2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        dragon2program2xi = get2kernelworkgroupinfo4dragon(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4dragon-performed-by-get2kernelworkgroupinfo-of-DRAGON2Kernel4Xi: " + str(get2kernelworkgroupinfo4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dragon2program2xi-returning-by-get2kernelworkgroupinfo-of-DRAGON2Kernel4Xi: " + str(dragon2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return dragon2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR DRAGON ', time4xi()) 
    #   try:
    #       kernelobject2dragon = DRAGON2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2dragon.create2kernel()
    #       print('(Step 190B/700) OF DRAGON2KERNEL4XI5TEST - CREATED KERNEL FOR DRAGON ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR DRAGON ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of DRAGON2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-DRAGON2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4dragon-by-create2kernel-of-DRAGON2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        dragon2kernel2xi = create2kernel4dragon(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4dragon-performed-by-create2kernel-of-DRAGON2Kernel4Xi: " + str(create2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4dragon at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = dragon2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-DRAGON2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # dragon2sampler4xi5test 
        
        return dragon2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF DRAGON2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR DRAGON ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2dragon.create2kernelsinprogram()
    #       print('(Step 130A/700) OF DRAGON2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR DRAGON ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR DRAGON', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-DRAGON2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4dragon-by-create2kernelsinprogram-of-DRAGON2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        dragon2kernel2xi = create2kernelsinprogram4dragon(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4dragon-performed-by-create2kernelsinprogram-of-DRAGON2Kernel4Xi: " + str(create2kernelsinprogram4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4dragon at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dragon2kernel2xi-returning-by-create2kernelsinprogram-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return dragon2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-DRAGON2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF DRAGON WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4dragon + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4dragon + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2dragon.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF DRAGON2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of DRAGONWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF DRAGON WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-DRAGON2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4dragon-by-delete2kernel-of-DRAGON2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4dragon(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4dragon-performed-by-delete2kernel-of-DRAGON2Kernel4Xi: " + str(delete2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-DRAGON2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO SET KERNEL OF DRAGON: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2dragon.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF DRAGON2KERNEL4XI5TEST - SET KERNEL OF DRAGON: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF DRAGON: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel DRAGON objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-DRAGON2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4dragon-by-set2kernel-of-DRAGON2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        dragon2kernel2xi = set2kernel4dragon(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4dragon-performed-by-set2kernel-of-DRAGON2Kernel4Xi: " + str(set2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dragon2kernel2xi-returning-by-set2kernel-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return dragon2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR DRAGON: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2dragon.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF DRAGON2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR DRAGON ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR DRAGON ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-DRAGON2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4dragon-by-set2kernelarg-of-DRAGON2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        dragon2program2xi = set2kernelarg4dragon(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4dragon-performed-by-set2kernelarg-of-DRAGON2Kernel4Xi: " + str(set2kernelarg4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dragon2program2xi-returning-by-set2kernelarg-of-DRAGON2Kernel4Xi: " + str(dragon2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return dragon2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2dragon.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF DRAGON2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of DRAGON 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dragon2kernel2xi = get2kernelinfo4dragon(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; dragon2kernel2xi-returning-by-get2kernelinfo-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return dragon2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF DRAGON ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2dragon.get2kernelarginfo()
    #       print('(Step 106B/700) OF DRAGON2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF DRAGON ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF DRAGON ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of DRAGON
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dragon2kernel2xi = get2kernelarginfo4dragon(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; dragon2kernel2xi-returning-by-get2kernelarginfo-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return dragon2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF DRAGON2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2dragon.get2buildinfo()
    #       print('(Step 106A2/700) OF DRAGON2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF DRAGON2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of DRAGON2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dragon2build2xi = get2buildinfo4dragon(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; dragon2build2xi-returning-by-get2buildinfo-of-DRAGON2Kernel4Xi: " + str(dragon2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return dragon2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF DRAGON2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2dragon.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF DRAGON2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases DRAGON2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-DRAGON2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4dragon-by-release2kernel-of-DRAGON2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        dragon2kernel2xi = release2kernel4dragon(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4dragon-performed-by-release2kernel-of-DRAGON2Kernel4Xi: " + str(release2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dragon2kernel2xi-returning-by-release2kernel-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return dragon2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF DRAGON2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2dragon.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF DRAGON2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains DRAGON2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-DRAGON2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4dragon-by-retain-of-DRAGON2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        dragon2kernel2xi = retain2kernel4dragon(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4dragon-performed-by-retain2kernel-of-DRAGON2Kernel4Xi: " + str(retain2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dragon2kernel2xi-returning-by-retain2kernel-of-DRAGON2Kernel4Xi: " + str(dragon2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return dragon2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-DRAGON2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF DRAGON2KERNEL4XI5TEST - TRYING TO TRACE DRAGON: ', time4xi())      
    #   trace2dragon = None
    #   try:
    #       trace2dragon = programobject2dragon.trace2kernel() 
    #               print('(Step 210B/25) OF DRAGON2KERNEL4XI5TEST - TRACE2DRAGON: ', trace2dragon)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4dragon-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4dragon', 'METHOD': 'trace2kernel4dragon'}
    #        except:
    #           print('(Step 210Z1/25) OF DRAGON2KERNEL4XI5TEST *** FAILED TO TRACE DRAGON: ', trace2dragon) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces DRAGON2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-DRAGON2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4dragon-by-trace2kernel-of-DRAGON2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4dragon(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4dragon-performed-by-trace2kernel-of-DRAGON2Kernel4Xi: " + str(trace2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-DRAGON2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-DRAGON2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF DRAGON2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF DRAGON: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2dragon.execute2kernel() 
    #       print('(Step 220B/25) OF DRAGON2KERNEL4XI5TEST - UNLOADED COMPILER OF DRAGON: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF DRAGON2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF DRAGON: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-DRAGON2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4dragon-by-execute2kernel-of-DRAGON2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4dragon(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4dragon-performed-by-execute2kernel-of-DRAGON2Kernel4Xi: " + str(execute2kernel4dragon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-DRAGON2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF DRAGON2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2DRAGON: ', programobject2dragon) 
    #   try:
    #       callback2dragon = programobject2dragon.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF DRAGON2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2dragon)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of DRAGON2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DRAGON2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-DRAGON2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-DRAGON2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2dragon4program = {} 
        try:
            callback2dragon4program = set2kernelcallback4dragon (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2dragon4program-failed-by-set2kernelcallback-of-DRAGON2Kernel4Xi: " + str(callback2dragon4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2dragon4program-returning-by-set2kernelcallback-of-DRAGON2Kernel4Xi: " + str(callback2dragon4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4dragon at 0x00000000038CF5C8> 
        
                                             
        return callback2dragon4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF DRAGON2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2dragon.sense())
    #       print('(Step 310B/700) OF DRAGON2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses DRAGON2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'DRAGON2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; DRAGON2Kernel4Xi-sensing-by-sense-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-DRAGON2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2dragon-of-DRAGON2Kernel4Xi'] = DRAGON2Kernel4Xi.classvariable2dragon
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-DRAGON2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; DRAGON2Kernel4Xi-sensed-by-sense-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-DRAGON2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-DRAGON2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF DRAGON2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2dragon.reason())
    #       print('(Step 320B/700) OF DRAGON2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons DRAGON2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'DRAGON2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; DRAGON2Kernel4Xi-reasoning-by-reason-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-DRAGON2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-DRAGON2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-DRAGON2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; DRAGON2Kernel4Xi-reasoned-by-reason-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-DRAGON2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-DRAGON2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF DRAGON2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2dragon.ace())
    #       print('(Step 330B/700) OF DRAGON2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF DRAGON2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces DRAGON2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'DRAGON2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-DRAGON2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; DRAGON2Kernel4Xi-acing-by-ace-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-DRAGON2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-DRAGON2Kernel4Xi'] = DRAGON2Kernel4Xi.classvariable2dragon
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-DRAGON2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; DRAGON2Kernel4Xi-aced-by-ace-of-DRAGON2Kernel4Xi: " + str(DRAGON2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'dragon2codeprogram4xi.DRAGON2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-DRAGON2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   dragon2codeprogram4xi5test.txt
#   sense-dragon2codeprogram4xi5test.xml
#   reason-dragon2codeprogram4xi5test.xml
#   ace-dragon2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dragon2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
